( ScanFor v0.11 by Gyroplast <gyroplast@gyroplast.com>
  Quick hack for easy location lookup of players.
   
  This code is released under the GPL, which can be found in it's
  entire length here: http://www.fsf.org/licenses/gpl.html
  CHANGES:
    23/Jun/2002 - v0.1 released
    24/Jun/2002 - v0.11, added %L substitution and license info in header
 
)
 
$def DEFAULT_MSG "Player %n(#%d) is currently in %l(#%L)."
( Help and version information )
: ShowHelp ( -- )
  " " .tell
  "ScanFor v0.11  -  A quick hack for easy location lookup of players" .tell
  "-----------------------------------------------------------------" .tell
  "  Usage: " trig name strcat " <target name>" strcat .tell
  "  where <target name> is a (partial) name of a player." .tell
  " " .tell
  "  A Customized answer string can be set on yourself in the" .tell
  "    _scanfor/msgstr" .tell
  "  property, with currently these substitutions:" .tell
  "  %n - Name of target      %l - Location of target" .tell
  "  %d - Dbref# of target    %L - Dbref# of location" .tell
  " " .tell
  "  The default string is \"Player %n(#%d) is currently in %l(#L).\"" .tell
  " " .tell
;
 
( Retrieve _scanfor/msgstr as message string with substitutions to use here.
  If this property is empty, use the DEFINEd default instead. Used
  substitutions are %n for the name of the target, and %l for it's location )
: GetSubstStr (  -- s )
  me @ "_scanfor/msgstr" getpropstr  ( Get prop on user )
  dup not if   ( If empty or not found.. )
    pop DEFAULT_MSG  ( Pop the nullstring and use the defined default )
  then  
  ( Otherwise just go on with the getpropped message on the stack )
;
 
( Take dbref of target and message string, and do all necessary substitions. )
: DoSubs ( d s -- s )
  over name
  "%n"
  subst ( Placeholder in message string substituted by name of target )
  over intostr
  "%d"
  subst ( Placeholder in message string substituted by dbref of target )
  over location name
  "%l"
  subst ( Placeholder in message string substituted by location of target )
  swap location intostr
  "%L"
  subst ( Placeholder in message string substituted by dbref of location )
;
 
: main
  me @ "W" flag? not if  ( Wiz only. Really. )
    "Only wizzes may use this program. Exiting." .tell
    exit
  then
  
  dup "#h" stringpfx if  ( Ask for help? Go get it. Also catches empty parm! )
    pop ShowHelp
    exit
  then
 
  .pmatch   ( Lookup dbref on stack for given partial player name )
  dup #-1 dbcmp if            ( Not found )
    "No target with this name found, please specify the target again." .tell
    exit
  then
  dup #-2 dbcmp if            ( Ambiguous Name )
    "This name is ambiguous, please specify the target again." .tell
    exit
  then
  dup ok? not if              ( Check for invalid dbref. Crashes are evil. )
    "Invalid DBREF#. Please specify another target." .tell
    exit
  then
  dup player? not if          ( Shall only work for player objects. )
    "This program only works for player names. Please choose another target."
    .tell exit
  then
  
  GetSubstStr ( Get message string from self or choose default if not present )
  DoSubs      ( Do substitutions with dbref and string on stack)
  .tell       ( Print result )
;
( This program was mechanically created and is valid without signature. )

