( lingo-say.muf -- Rajhea's species-specific say program )
$def version prog "_version" getpropstr
$def person? dup thing? if "Z" flag? else player? then
$def streq stringcmp not
lvar lingo
lvar group
: padstring ( s i -- s )
   swap "                                        " strcat
   swap strcut pop
;
: getlingo ( dbref -- lingo )
   dup "lingo/species" getpropstr
   dup if swap pop else pop "~lingo/native" getpropstr then
;
: getspeech ( -- speech )
 ( trig lingo @ "/speech" strcat getpropstr strip " " strcat )
   me @ "lingo/speech" getpropstr
;
: getosay ( -- osay )
   me @ "lingo/osay" getpropstr
   dup not if pop
    trig "osay/" group @ strcat getpropstr
    dup not if pop "says" then
   then
;
lvar word
: randspeech ( wordlist -- word )
   "|" explode
   random over %
   begin dup while
    1 - swap 1 - swap
    rot pop
   repeat pop
   1 - swap word !
   begin dup while
    1 - swap pop
   repeat pop
   "<" word @ strip ">" strcat strcat
;
$def randsay getspeech dup if randspeech else pop "<>" then
: lingotogroup ( lingo -- group )
   trig over "/group" strcat getpropstr
   dup if swap then pop
;
: lingo-help
   "Rajhea's species-specific say program." .tell
   " " .tell
"Allows members of the same species to talk together in their own language"
   .tell
"without giving away privileged information to members of other species who"
   .tell
"may be listening." .tell
   " " .tell
"For the purposes of this program, your species is stored on the lingo/species"
   .tell
"prop.  Characters with the same species setting will be able to understand"
   .tell
"each other fully, and certain related species will have partial understanding"
   .tell
"(e.g. wolf and fox are both languages in the canine group, so a wolf will"
   .tell
"understand some of what a fox says, and vice versa)." .tell
   " " .tell
   "Other props used by this program :" .tell
   "   lingo/osay -- say verb, if you don't like the species default." .tell
   "   lingo/speech -- noise words used to replace speech for listeners" .tell
   "                   with only a partial understanding of your language" .tell
   "       e.g. for a fox: @set me=lingo/speech:yip|yap|yerf|tail-fluff|whine" .tell
   "   lingo/ignore -- prop set by the #ignore option." .tell
   " " .tell
   "Use " command @ " #setup to set your species prop." strcat strcat .tell
   "    " command @ " #ignore to hide yourself from the lingo-say program."
   strcat strcat .tell
;
: lingo-ignore
   me @ player? if
    "Hypnotising the lingo-say program ..." .tell
    10 sleep
    me @ "lingo/ignore" "yes" setprop
    "Hypnosis complete.  Lingo-say is no longer aware of your existence."
    .tell
   else
    "Sorry, I can only ignore players." .tell
   then
;
lvar line
: getonespecies
   dup if
    1 - swap
    " (" over lingotogroup ")" strcat strcat strcat
    25 padstring line @ swap strcat line !
   then
;
$def addspaces " " swap " " strcat strcat
: lingo-setup
   "Rajhea's species-specific say program." .tell
   " " .tell
   "Currently available species :" .tell
   trig "specieslist" getpropstr " " explode
   begin dup while
    "   " line !
    getonespecies getonespecies getonespecies
    line @ .tell
   repeat
   " " .tell
   "Contact " trig owner name " if the species you want is not listed."
   strcat strcat .tell
   begin
    " " .tell
    "Your current say-species is "
    me @ getlingo dup not if pop "[unset]" then strcat
    ".  Enter new species (@Q to abort) ?" strcat .tell
    read strip dup dup if
     addspaces
     trig "specieslist" getpropstr addspaces
     swap instr not
    then   while    pop "I don't recognise that species." .tell   repeat   dup if    me @ "lingo/species" rot setprop    "Your say-species has been set." .tell   else    pop "Your say-species has been left unchanged." .tell   then ;
lvar newtext
lvar level
: makeleveltext ( text level -- newtext )   1 - level ! "" newtext !   " " explode   begin dup while    1 - swap    random    over strlen dup 4 < if pop 4 then    % level @ > if pop randsay then    newtext @ swap " " strcat strcat    newtext !   repeat   pop newtext @ strip ;
$def quote "\"" swap "\"" strcat strcat
: sayit ( dbref text -- dbref )   me @ name " " strcat getosay strcat ", " strcat swap strcat   over swap notify ;
: sayit1   quote " (in " lingo @ ")" strcat strcat strcat sayit ;
: getlevel ( dbref -- level )   dup "~lingo/" lingo @ strcat "/level" strcat getpropstr atoi   swap getlingo lingotogroup group @ streq if 3 + then ;
: dotalk ( text dbref -- [same] )   dup person? over owner "lingo/ignore" getpropstr and not if    dup getlingo lingo @ streq if over sayit1 exit then    dup "~lingo/wiz" getpropstr if over sayit1 exit then    dup getlevel dup if 3 pick swap makeleveltext sayit1 exit then    pop "<something you can't understand>" sayit   then ;
: talkloop   loc @ contents   begin    dup #-1 dbcmp not   while    dotalk    next   repeat pop   loc @ dotalk ( for the benefit of _listens )   pop pop ;
: main ( me @ owner "lingo/ignore" getpropstr if ) (  pop "$huh?" match call exit            ) ( then                                    )   strip   dup not if pop    prog name " v" strcat version strcat ", by Rajhea Skunk." strcat .tell    "Use " command @ " #help for help." strcat strcat .tell exit   then   dup "#*" smatch if    dup "#help" streq if pop lingo-help exit then    dup "#setup" streq if pop lingo-setup exit then    dup "#ignore" streq if pop lingo-ignore exit then  ( dup "#teach *" smatch if lingo-teach exit then )  ( dup "#status" streq if lingo-status exit then )   then   me @ getlingo dup not if pop    "Use " command @ " #setup to set yourself for lingo-say." strcat strcat    .tell exit   then   dup lingotogroup group ! lingo !   talkloop ;

