(
  MAKEMIX.MUF  v1.21   by Gyroplast   07/31/98                                
                                                                              
  A program to create edible or drinkable objects!                            
 
  To install the program anywhere, do the following:
  
    1. @act install=me
    2. @link install=<dbref# of this program>
    3. Go to the room where makemix is supposed to be installed
    4. Type 'install #setup' and follow the instructions
    5. Repeat steps 3-4 as often as necessary
    6. @rec install   when you're done
 
  Recent changes:  
                  v1.21 - MPI evaluation in messages
                  v1.20 - Setup frontend added for easier installation                                                           
                  v1.10 - Custom make and mix commands possible               
                  v1.02 - Dropped and ate food is sent to recycle bin         
                  v1.01 - Zombies can order now                               
  Have phun!                                                                  
                                                                              
)
                                                                               
(** Change this to the dbref of the room used as a garbage container ** )
$def garbage #746
(** May zombies order? Set this either to 1 or 0 **)
$def zallow? 1
$def makesuccDEF "You create %X from thin air!"
$def makeosuccDEF "%n creates %X from thin air!"
$def mixsuccDEF "You create %X from thin air!"
$def mixosuccDEF "%n creates %X from thin air!"
lvar makesucc
lvar makeosucc
lvar mixsucc
lvar mixosucc
lvar objno
: makeok
  me @ location
  "_makeok?" getpropstr "yes" stringcmp not
;
: mixok
  me @ location
  "_mixok?" getpropstr "yes" stringcmp not
;
: getmesgs
  me @ location "_make/succ" "(@succ)" 1 parseprop makesucc !
  me @ location "_make/osucc" "(@osucc)" 1 parseprop makeosucc !
  me @ location "_mix/succ" "(@succ)" 1 parseprop mixsucc !
  me @ location "_mix/osucc" "(@osucc)" 1 parseprop mixosucc !
  makesucc @ not if makesuccDEF makesucc ! then
  makeosucc @ not if makeosuccDEF makeosucc ! then
  mixsucc @ not if mixsuccDEF mixsucc ! then
  mixosucc @ not if mixosuccDEF mixosucc ! then
;
: create_food
  dup
  me @
  zallow? not if
   dup player? not if "Sorry, only players can order here!" .tell exit then
  then 
  location
  swap
  newobject
  dup objno !
  dup me @ moveto
  over over swap
  "Looks like a tasty " swap strcat "!" strcat
  setdesc
  swap
  "Smells like a fresh " swap strcat "!" strcat
  "_scent" swap 0 addprop
  objno @
  dup "_edible" "yes" 0 addprop
  dup "_drinkable" "no" 0 addprop
  dup garbage setlink
  "s" set
  makesucc @ objno @ name "%X" subst makesucc !
  makeosucc @ objno @ name "%X" subst makeosucc !
  me @ makesucc @ pronoun_sub makesucc !
  me @ makeosucc @ pronoun_sub makeosucc !
  makesucc @ .tell
  makeosucc @ .otell
;
: create_drink
  dup
  me @
  zallow? not if
   dup player? not if "Sorry, only players can order here!" .tell exit then
  then
  location
  swap
  newobject
  dup objno !
  dup me @ moveto
  over over swap
  "A refreshing and tasty " swap strcat "!" strcat
  setdesc
  swap
  "Smells like a refreshing " swap strcat "!" strcat
  "_scent" swap 0 addprop
  objno @ 
  dup "_edible" "no" 0 addprop
  dup "_drinkable" "yes" 0 addprop
  dup garbage setlink
  "s" set
  mixsucc @ objno @ name "%X" subst mixsucc !
  mixosucc @ objno @ name "%X" subst mixosucc !
  me @ mixsucc @ pronoun_sub mixsucc !
  me @ mixosucc @ pronoun_sub mixosucc !
  mixsucc @ .tell
  mixosucc @ .otell
;
: help
  " " .tell
  "USAGE:" .tell
  "  "
  TRIG "_drink" getpropstr dup not if pop "MIX" else STRIP toupper then 
  " <name of drink>" strcat strcat .tell
  "  "
  TRIG "_food" getpropstr dup not if pop "MAKE" else STRIP toupper then 
  " <name of food>" strcat strcat .tell
;
: DeleteOldActions
  "Deleting old make/mix actions..." .tell
  contents
  BEGIN
   dup #-1 dbcmp not while
   dup exit? if dup getlink prog dbcmp if dup recycle then then
   next
  REPEAT
  pop
  "Done." .tell
;
: do_setup
  me @ dup location owner dbcmp not if
   "You do not own this room." .tell exit then
  "Setup started. Enter @Q at any time to abort." .tell
  me @ location
  DeleteOldActions
  "Allow mixing drinks here? (y/N)" .tell
  READ STRIP  
  "y" stringpfx 1 = if
   "YES" .tell
   me @ location "_mixok?" "yes" 1 ADDPROP
  else 
   "NO" .tell 
   me @ location "_mixok?" "no" 1 ADDPROP
  then
  "Allow making food here? (y/N)" .tell
  READ STRIP
  "y" stringpfx 1 = if
   "YES" .tell
   me @ location "_makeok?" "yes" 1 ADDPROP
  else
   "NO" .tell
   me @ location "_makeok?" "no" 1 ADDPROP
  then
  " " .tell
  "What's the command for mixing drinks? (A ' ' for default)" .tell
  READ STRIP
  dup not if pop "mix" then
  me @ location over newexit
  dup prog setlink
  swap "_drink" swap 1 ADDPROP
  " " .tell
  "What's the command for making food? (A ' ' for default)" .tell
  READ STRIP
  dup not if pop "make" then
  me @ location over newexit
  dup prog setlink
  swap "_drink" swap 1 ADDPROP
  getmesgs
  " " .tell
  "Message shown to you when successfully mixing a drink:" .tell
  mixsucc @ .tell
  "Enter new message, a space to keep that one, or '.' to set the default." .tell
  "(%X will be substituted with the drink's name)" .tell
  READ STRIP
  dup "." stringpfx 1 = if
   me @ location "_mix/succ" remove_prop
  then
  dup if
   me @ location swap "_mix/succ" swap 1 ADDPROP
  then
  " " .tell
  "Message shown to others when successfully mixing a drink:" .tell
  mixosucc @ .tell
  "Enter new message, a space to keep that one, or '.' to set the default." .tell
  "(%X will be substituted with the drink's name)" .tell
  READ STRIP
  dup "." stringpfx 1 = if
   me @ location "_mix/osucc" remove_prop
  then
  dup if
   me @ location swap "_mix/osucc" swap 1 ADDPROP
  then
  " " .tell
  "Message shown to you when successfully making food:" .tell
  makesucc @ .tell
  "Enter new message, a space to keep that one, or '.' to set the default." .tell
  "(%X will be substituted with the drink's name)" .tell
  READ STRIP
  dup "." stringpfx 1 = if
   me @ location "_make/succ" remove_prop
  then
  dup if
   me @ location swap "_make/succ" swap 1 ADDPROP
  then
  " " .tell
  "Message shown to others when successfully making food:" .tell
  makeosucc @ .tell
  "Enter new message, a space to keep that one, or '.' to set the default." .tell
  "(%X will be substituted with the drink's name)" .tell
  READ STRIP
  dup "." stringpfx 1 = if
   me @ location "_make/osucc" remove_prop
  then
  dup if
   me @ location swap "_make/osucc" swap 1 ADDPROP
  then
  "Setup finished. " .tell
;
: main
  STRIP
  dup "#h" stringpfx 1 = if pop help exit then
  dup "#s" stringpfx 1 = if pop do_setup exit then
  dup "#" stringpfx 1 = over "*" stringpfx 1 = OR
  if
   pop "This name is not allowed." .tell
   exit
  then
  dup not if
   "You should at least tell me a name for the food/drink!" .tell exit
  then
  getmesgs
  command @ "make" stringcmp not 
  TRIG "_food" getpropstr STRIP command @ stringcmp not OR if
   makeok if 
    create_food exit else "This is not allowed here!" .tell exit 
   then
  then
  command @ "mix" stringcmp not
  TRIG "_drink" getpropstr STRIP command @ stringcmp not OR if
   mixok if
    create_drink exit else "This is not allowed here!" .tell exit
   then
  then
;

