(
           REQ.MUF     by Gyroplast  12/16/98  v1.2a
 
   This is a clone of the famous @request program, with some
   enhancements and modifications for mucks with rigid species and gender
   settings.
 
   Needs wizbit.
 
   To use it, link a global action named @request to it. Then define a
   wizbitted player object to be forced to do the @pcreates below, and you're 
   all set. 
  
   It is now possible to specifically allow/disallow players from processing
   requests, entirely independent from a wizbit. All you need to do is to
   add or remove players from a list with the supplied commands.
   By default, all wizzes and no mortals are allowed to process requests.
   For information on how to handle the list, see the program help.
 
   If you want wizzes to be notified of unprocessed requests when
   logging in, type this:
    @set #0=_connect/req:&{muf:<db# of this program>,unprocessedrequests}
   If you want any additional features or if you spot a bug, report it to
   the owner of this program or directly to Gyroplast.
 
   This program may be freely distributed, ported, and changed to fit any
   special needs of your muck, but it'd be nice if you notify me of any
   portings.
 
   Have phun!
  
   Check http://www.gyroplast.com for newer versions and other mufs, or
   contact me at gyroplast@gyroplast.com !
)
$def validchars "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
LVAR realname
LVAR charname
LVAR sex
LVAR species
LVAR chardb
LVAR password 
LVAR email
LVAR DOB
LVAR ProcD
LVAR ReqD
LVAR processor
LVAR hostname
LVAR Reqno
LVAR city
LVAR temp
LVAR temp2
 
( Include useful reflist management functions found in the fuzzball basedb )
$include $lib/reflist
 
(------------------- BEGIN OF CONFIGURATION PART -------------------)
( FORCEDAEMON contains the dbref of the player who's 
  forced to do the @pcreates. Do NOT use #1. It wont work with GOD_PRIV. 
  Either use any wiz here, or create a wizbitted player solely used for this
  and similar purposes. )
 
$def FORCEDAEMON #3494
 
( The adminlist contains the dbrefs of the players with admin rights;
  Only those can delete entries.
  If commented out, everyone permitted to create/deny chars is allowed to
  delete the info as well. Seperate dbrefs with single spaces. )
 
$def adminlist "#1 #3494 #118 #352 #2813 #13615"
 
( Set the values below to reflect the name of the species and sex property
  on your muck. Leave commented out if @request shall not ask for this info. )
 
($def SPECIESPROP "~species")
($def SEXPROP "~sex")
 
( If your muck allows only certain species and genders, uncomment the $defs
  below and edit the list as you please.
  To allow any {I MEAN any, even a gender like 'flotznic' would be possible!}
  gender or species, leave the $def commented out. )
  
($def ALLOWEDSPECIES "fox;bear;cat;rabbit;tiger")
($def ALLOWEDSEX "male;female;herm;neuter")
( These properties set on the program store the reflists of the players
  who are authorized to process requests. Usually unnecessary to change them. )
$def includelist "_include"
$def excludelist "_exclude"
  
( The iswiz? function determines who's allowed to create and deny chars.
  Feel free to tweak it if necessary, but remember that this is one of
  the key functions, so watch your step... )
 
: iswiz?  ( d -- b ) 
  prog excludelist 3 pick REF-inlist? if pop 0 exit then
  prog includelist 3 pick REF-inlist? if pop 1 exit then
$ifdef adminlist
  dup intostr " " strcat "#" swap strcat
  adminlist STRIP " " strcat swap instring if pop 1 exit then
$endif
  "W" flag?
;
 
 
(-------------- BEGIN OF PROGRAM CODE, BETTER DONT EDIT ------------)
: pad
  swap "                                                                                " strcat swap strcut pop
;
: admin?  ( d -- b )
$ifdef adminlist
  intostr " " strcat "#" swap strcat
  adminlist STRIP " " strcat swap instring
$else
  iswiz?
$endif
;
: delreqtree
  PROG
  dup "@request/charname/" reqno @ strcat remove_prop
  dup "@request/chardb/" reqno @ strcat remove_prop
  dup "@request/email/" reqno @ strcat remove_prop
  dup "@request/hostname/" reqno @ strcat remove_prop
  dup "@request/ProcD/" reqno @ strcat remove_prop
  dup "@request/ReqD/" reqno @ strcat remove_prop
  dup "@request/Processor/" reqno @ strcat remove_prop
  dup "@request/DOB/" reqno @ strcat remove_prop
  dup "@request/realname/" reqno @ strcat remove_prop
  dup "@request/city/" reqno @ strcat remove_prop
$ifdef SPECIESPROP
  dup "@request/species/" reqno @ strcat remove_prop
$endif
$ifdef SEXPROP
  dup "@request/sex/" reqno @ strcat remove_prop
$endif
  pop
;
: getnextreqno
  PROG
  "@request/no" getpropstr atoi
  1 +
  intostr
;
: gethostname
  me @ descriptors
  BEGIN
    dup 1 = if
      pop break
    else
      1 - swap pop
    then
  REPEAT
  descrcon
  dup conhost " (" strcat swap conuser ")" strcat strcat
; 
: getrequestinfo
  intostr reqno !
  PROG
  dup "@request/charname/" reqno @ strcat getpropstr charname !
  dup "@request/chardb/" reqno @ strcat getpropstr chardb !
  dup "@request/email/" reqno @ strcat getpropstr email !
  dup "@request/ReqD/" reqno @ strcat getpropstr reqD !
  dup "@request/hostname/" reqno @ strcat getpropstr hostname !
  dup "@request/ProcD/" reqno @ strcat getpropstr dup if
    ProcD !
    dup "@request/processor/" reqno @ strcat getpropstr processor !
  else
    pop "*Not Processed*" dup ProcD ! processor !
  then 
  dup "@request/DOB/" reqno @ strcat getpropstr DOB !
  dup "@request/realname/" reqno @ strcat getpropstr realname !
  dup "@request/city/" reqno @ strcat getpropstr city !
$ifdef SPECIESPROP
  dup "@request/species/" reqno @ strcat getpropstr species !
$endif
$ifdef SEXPROP
  dup "@request/sex/" reqno @ strcat getpropstr sex !
$endif
  pop
;
: listinfo
  " --- Request #" reqno @ strcat " ---" strcat .tell
  " " .tell
  "  Real name         : " realname @ strcat .tell
  "  Character name    : " charname @ strcat .tell
$ifdef SPECIESPROP
  "  Character species : " species @ strcat .tell
$endif
$ifdef SEXPROP
  "  Character gender  : " sex @ strcat .tell
$endif
  "  DataBase #        : " chardb @ dup not if pop "None" else "#" swap strcat then
  strcat .tell
  "  E-Mail            : " email @ strcat .tell
  "  Date of Birth     : " dob @ strcat .tell
  "  City/State        : " city @ strcat .tell
  "  Host              : " hostname @ strcat .tell
  "  Requested         : " ReqD @ strcat .tell
  "  Processed         : " ProcD @ strcat .tell
  "  Processed by      : " processor @ strcat .tell
;
: dateok?
  "" " " SUBST
  dob !
  "/" explode
  dup 3 = not if
   BEGIN
     dup not if
       break
     else
       1 - swap pop
     then
   REPEAT
   0 exit
  then
  pop
  atoi
  dup 12 > over 1 < OR if pop pop pop 0 exit then
  intostr dup strlen 1 = if "0" swap strcat then
 me @ iswiz? not if "This is for wizzes only. To request a character, type @request" .tell exit then
  "/" strcat
  swap
  atoi
  dup 31 > over 1 < OR if pop pop pop 0 exit then
  intostr dup strlen 1 = if "0" swap strcat then
  "/" strcat strcat
  swap
  atoi
  dup 99 > over 0 < OR if pop pop 0 exit then
  intostr dup strlen 1 = if "0" swap strcat then
  strcat
  dup strlen 8 = not if pop 0 else dob ! 1 then
;
: notify-wizzes
  online
  BEGIN
   dup not if pop break then
   1 - swap
   dup iswiz? if
    dup "H" flag? not over "_request-notify?" getpropstr "no" stringcmp and if
     dup "*@REQUEST* " me @ name strcat " just requested a character." strcat notify
     "See @request #info " reqno @ strcat " for details." strcat notify
    then
   else
    pop
   then
  REPEAT
;
: do-request
  " " .tell
  "You just decided to @request a character!" .tell
  "Now you'll be asked some questions about you and your character," .tell
  "and after that, your request will be saved." .tell
  "Processing a request is usually done within 24 hours; You'll be" .tell
  "notified by email when your character is created. If you" .tell
  "do any typos, or mess up the @request otherwise, just submit" .tell
  "another one. The newest request will be used for creation." .tell
  "NOTE: Make sure you read 'news registration' first and" .tell
  "      accept all terms therein." .tell
  " " .tell
  "DO NOT LIE TO US! Falsification of player data will" .tell
  "result in removing your character permanently from the muck!" .tell
  " " .tell
  "  Continue? (y/n)" .tell
  READ STRIP
  "y" stringpfx 1 = not if "Aborted." .tell exit then
  " " .tell " " .tell
  "To abort the program at any time, type '.'" .tell
  " " .tell
  getnextreqno
  reqno !
  BEGIN
    "Enter the name of your character : " .tell
    READ STRIP
    dup "." strcmp not if "Aborted." .tell exit then
    dup
    charname !
    dup " " instring 
     if "Character names must not contain spaces!" .tell continue then
    dup strlen 15 > 
     if "Character names must not be longer than 15 letters!" .tell continue then
    .pmatch #-1 dbcmp not 
     if "This name is taken already, think of another one." .tell continue then
    break
  REPEAT
  PROG "@request/charname/" reqno @ strcat charname @ 0 ADDPROP
$ifdef SPECIESPROP
  BEGIN
    "Enter the species of your character : " .tell
    READ STRIP
    dup "." strcmp not if "Aborted." .tell delreqtree exit then
    dup
    species !
$ifdef ALLOWEDSPECIES
    strip ALLOWEDSPECIES over instring not swap ";" instring OR
     if "This is not an allowed species. Pick one from the list:" .tell ALLOWEDSPECIES .tell continue then
$endif
    break
  REPEAT
  PROG "@request/species/" reqno @ strcat species @ 0 ADDPROP    
$endif
 
$ifdef SEXPROP
  BEGIN
    "Enter the gender of your character : " .tell
    READ STRIP
    dup "." strcmp not if "Aborted." .tell delreqtree exit then
    dup
    sex !
$ifdef ALLOWEDSEX
    strip ALLOWEDSEX over instring not swap ";" instring OR
     if "This is not an allowed gender. Pick one from the list:" .tell ALLOWEDSEX .tell continue then
$endif
    break
  REPEAT
  PROG "@request/sex/" reqno @ strcat sex @ 0 ADDPROP    
$endif
 
  BEGIN
    "Enter your email-address : " .tell
    READ STRIP
    dup "." strcmp not if "Aborted." .tell delreqtree exit then
    dup
    email !
    dup "@" instring not 
    over "." instring not OR 
    swap " " instring OR 
     if "This is not a valid eMail address!" .tell continue then
    break
  REPEAT
  PROG "@request/email/" reqno @ strcat email @ 0 ADDPROP    
  PROG "@request/hostname/" reqno @ strcat gethostname 0 ADDPROP
  PROG "@request/ReqD/" reqno @ strcat "%x at %X %Z" systime timefmt 0 addprop
  " Do you want to register as an adult?" .tell
  " " .tell
  " You will be asked for :" .tell
  "  Your REAL name," .tell
  "  your birthdate," .tell
  "  and your city/state." .tell
  " " .tell
  " If you do not wish to submit these information," .tell
  " or you are a minor anyway, say 'no' here." .tell
  " Otherwise say 'yes' to gain access to the adult areas and programs." .tell
  READ STRIP
  dup "y" STRINGPFX 1 = if pop
   " " .tell
   "Enter your REAL last name (eg. Smith) :" .tell
   READ STRIP 
   dup "." strcmp not if pop "Aborted." .tell delreqtree exit then
   realname !
   "Enter your REAL first name (eg. John) :" .tell
   READ STRIP 
   dup "." strcmp not if pop "Aborted." .tell delreqtree exit then
   " " realname @ strcat strcat realname !
   "Enter your city/state :" .tell
   READ STRIP
   dup "." strcmp not if pop "Aborted." .tell delreqtree exit then
   city !
   BEGIN
    "Enter your date of birth (MM/DD/YY) :" .tell
    READ STRIP
    dup "." strcmp not if pop "Aborted." .tell delreqtree exit then
    dup dateok? not if
     "This is not a valid date! Try again!" .tell continue
    else
     break
    then
   REPEAT
  else
   "*No adult request*" dup dup realname ! city ! DOB !
  then
  PROG "@request/realname/" reqno @ strcat realname @ 0 ADDPROP
  PROG "@request/city/" reqno @ strcat city @ 0 ADDPROP
  PROG "@request/dob/" reqno @ strcat DOB @ 0 ADDPROP
  " " .tell
  "You submitted this information:" .tell
  " " .tell
  reqno @ atoi
  getrequestinfo
  listinfo
  " " .tell
  "Is all this correct? (y/n)" .tell
  READ STRIP
  "y" stringpfx 1 = not if "Request aborted! Please re-enter all information!" .tell delreqtree exit then  
  " " .tell
  "Thank you for filling out this form! Your request is filed now," .tell
  "and will be processed by the next wizard being online." .tell
  "Enjoy your stay on " "muckname" sysparm strcat "!" strcat .tell
  
  BACKGROUND
  PROG "@request/no" over over getpropstr atoi 1 + intostr 0 ADDPROP
  notify-wizzes
;
: GetUnprocCount
  PROG "@request/no" getpropstr atoi
  dup not if exit then
  0
  BEGIN
    over while
    over intostr "@request/ProcD/" swap strcat PROG swap getpropstr
    not if 1 + then
    swap 1 - swap
  REPEAT
  swap pop
;
: warn-unproc
  me @ iswiz? not if exit then
  GetUnprocCount
  dup not if pop exit then
  dup 1 = if pop "There is 1 new @request for a character! Check @request #new !" .tell exit then
  intostr "There are " swap strcat " new @requests for a character! Check @request #new !" strcat .tell
;
: showinfo
  getrequestinfo
  charname @ not if "This request # does not exist!" .tell else
  listinfo then
;
: shownew
  PROG "@request/no" getpropstr atoi
  "--- Unprocessed requests" .tell
  " " .tell
  BEGIN
   dup not if break then
   dup getrequestinfo
   ProcD @ "*Not Processed*" strcmp not
   ProcD @ "*DELETED*" strcmp AND if
    dup intostr "Request #" swap strcat "  -  Name: " strcat
    charname @ 17 pad strcat "  Date: " strcat ReqD @ strcat .tell
   then
   1 -
  REPEAT
  " " .tell
  "Done." .tell
;
: showold
  PROG "@request/no" getpropstr atoi
  "--- Processed requests" .tell
  " " .tell
  BEGIN
   dup not if break then
   dup getrequestinfo
   ProcD @ "*Not Processed*" strcmp if
    dup intostr "Request #" swap strcat "  -  Name: " strcat
    charname @ 17 pad strcat "  Date: " strcat ReqD @ strcat
    "  Processed by: " strcat processor @ strcat .tell
   then
   1 -
  REPEAT
  " " .tell
  "Done." .tell
;  
: do-create
  getrequestinfo
  charname @ not if "This request # doesn't exist." .tell exit then
  ProcD @ "*DELETED*" strcmp not if "This is and old, deleted request!" .tell exit then
  listinfo
  "You really want to create this character?" .tell
  READ STRIP
  "y" STRINGPFX 1 = not if "Aborted. Nothing done." .tell exit then
  "" 6
  BEGIN
    dup not if pop break then
    swap validchars dup strlen random swap % strcut
    1 strcut pop swap pop strcat
    swap 1 -
  REPEAT
  password !
  charname @ .pmatch
  #-1 dbcmp not if "A character with that name already exists! Maybe this request has been processed already?" .tell exit then
  FORCEDAEMON "@pcreate " charname @ strcat "=" strcat password @ strcat force
  "Setting properties..." .tell
  PROG "@request/procD/" reqno @ strcat "%x at %X %Z" systime timefmt 0 ADDPROP
  PROG "@request/processor/" reqno @ strcat me @ name 0 ADDPROP
  charname @ .pmatch temp !
  PROG "@request/chardb/" reqno @ strcat temp @ intostr 1 ADDPROP
  temp @
$ifdef SPECIESPROP
  dup SPECIESPROP species @ 0 ADDPROP
$endif
$ifdef SEXPROP
  dup SEXPROP sex @ 0 ADDPROP
$endif
  dup "@/eMail" email @ 0 ADDPROP
  dup "@/name" realname @ 0 ADDPROP
  dup "@/city" city @ 0 ADDPROP
  dup "@/adult" dob @ 0 ADDPROP
  dup "@/createdby" me @ name 0 ADDPROP
  "@/reqno" reqno @ 0 ADDPROP
  "Character '" charname @ strcat "' created. Marking as processed..." strcat .tell
  "Done." .tell
  "Assigned password: " password @ strcat .tell
;
: do-deny
  getrequestinfo
  charname @ not if "This request # doesn't exist!" .tell exit then
  procD @ "*Not Processed*" strcmp if "This request has been processed already!" .tell exit then
  listinfo
  " " .tell
  "Really deny this character? (y/n)" .tell
  READ STRIP
  "y" stringpfx 1 = not if "Aborted. Nothing done." .tell exit then
  "Enter the reason for denying this character request:" .tell
  READ temp !
  "Processing..." .tell
  PROG
  dup "@request/processor/" reqno @ strcat me @ name " (" strcat temp @ strcat ")" strcat 0 ADDPROP
  "@request/ProcD/" reqno @ strcat "Denied: %x at %X %Z" systime timefmt 0 ADDPROP
  " " .tell
  "Done." .tell
;
: help1
  " " .tell
  "@REQUEST   -   HELP" .tell
  "---------------------" .tell
  " " .tell
  " " .tell
  "  Guests and players may request new characters with this" .tell
  "  program, and after submitting all necessary information," .tell
  "  all connected wizzes will be informed." .tell
  " " .tell
  "  Wiz-Help  :  @request #help2" .tell
  "  Admin-Help:  @request #help3" .tell
  " " .tell
;
: help2
  " " .tell
  "@REQUEST   -   WIZ-HELP" .tell
  "-------------------------" .tell
  " " .tell
  " " .tell
  "  @request #help        -   Guess..." .tell
  "  @request #help2       -   No comment." .tell
  "  @request #req         -   Explicitly request a char" .tell
  "  @request #new         -   List new unprocessed requests" .tell
  "  @request #old         -   List old processed requests" .tell
  "  @request #create <#>  -   Process the specified request #" .tell
  "  @request #deny <#>    -   Deny creation of request #" .tell
  "  @request #info <#>    -   Show detailed information about request #" .tell
  " " .tell
;
: help3
  " " .tell
  "@REQUEST   -   ADMIN-HELP" .tell
  "-------------------------" .tell
  " " .tell
  " " .tell
  "  @request #delete <#>      -  Deletes old player information" .tell
  "  @request #list            -  View list of authorized users" .tell
  "  @request #include <name>  -  Add <name> to the list of authorized users" .tell
  "  @request #exclude <name>  -  Explicitly exclude <name> from the list of" .tell
  "                               authorized users" .tell
  " " .tell
;
: delinfo
  dup
  getrequestinfo
  charname @ not if "This request # does not exist!" .tell exit else
  listinfo then
  " " .tell
  "Do you really want to DELETE this information? (y/n)" .tell
  READ STRIP
  "y" stringpfx 1 = not if pop "Aborted." .tell exit then
  "Deleting..." .tell
  intostr reqno !
  PROG
  BEGIN
  dup "@request/charname/" reqno @ strcat
   over "@request/charname/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/chardb/" reqno @ strcat
   over "@request/chardb/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/email/" reqno @ strcat
   over "@request/email/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/hostname/" reqno @ strcat
   over "@request/hostname/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/realname/" reqno @ strcat
   over "@request/realname/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/ProcD/" reqno @ strcat
   over "@request/ProcD/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/ReqD/" reqno @ strcat
   over "@request/ReqD/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/Processor/" reqno @ strcat
   over "@request/Processor/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/DOB/" reqno @ strcat
   over "@request/DOB/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
  dup "@request/city/" reqno @ strcat
   over "@request/city/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
$ifdef SPECIESPROP
  dup "@request/species/" reqno @ strcat
   over "@request/species/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
$endif
$ifdef SEXPROP
  dup "@request/sex/" reqno @ strcat
   over "@request/sex/" reqno @ atoi 1 + intostr strcat getpropstr
  0 ADDPROP
$endif
  
  dup "@request/no" getpropstr reqno @ stringcmp not if
   "@request/no"
   over over getpropstr atoi 1 - intostr 0 addprop
   break
  else reqno @ atoi 1 + intostr reqno !
  then
  REPEAT
  "DONE." .tell
;
: intodbref
  dup .pmatch
  dup #-1 dbcmp not if swap pop exit then
  pop "" "#" subst atoi
  dup not if pop #-1 exit else dbref then
  dup player? not if pop #-1 exit then
;
: addtolist
  intodbref
  dup #-1 dbcmp if "This player could not be found." .tell exit then
  dup #-2 dbcmp if "Ambiguous name, try entering a dbref#." .tell exit then
  prog excludelist 3 pick REF-inlist? not over "W" flag? AND if
   "This player is a wiz, and not explicitly excluded from the list." .tell
   "You do not need to add this wizard." .tell exit 
  then
  dup name " (#" strcat over intostr strcat ") " strcat 
  "Do you really want to allow " swap strcat "to process requests? (y/n)" 
  strcat .tell
  read strip .no? if "Aborted." .tell exit then
  dup "W" flag? not if prog includelist 3 pick REF-add then
  prog excludelist 3 pick REF-delete
  name "Authorization granted to " swap strcat "." strcat .tell
;
: delfromlist
  intodbref
  dup #-1 dbcmp if "This player could not be found." .tell exit then
  dup #-2 dbcmp if "Ambiguous name, try entering a dbref#." .tell exit then
  prog includelist 3 pick REF-inlist? not over "W" flag? not AND if
   "This player is a mortal, and not explicitly included in the list." .tell
   "You do not need to exclude this mortal." .tell exit 
  then
  dup name " (#" strcat over intostr strcat ") " strcat
  "Do you really want to keep " swap strcat "from processing requests? (y/n)" 
  strcat .tell
  read strip .no? if "Aborted." .tell exit then
  dup "W" flag? if prog excludelist 3 pick REF-add then
  prog includelist 3 pick REF-delete
  name " is no longer authorized to process requests." strcat .tell
;
: showlist
  prog includelist REF-first temp !
  prog excludelist REF-first temp2 !
  " " .tell
  "  Authorized mortals                 Excluded wizzes" .tell
  "------------------------------------------------------" .tell
  "    "
  temp @ #-1 dbcmp if "<NONE>" else temp @ name then strcat 40 pad
  temp2 @ #-1 dbcmp if "<NONE>" else temp2 @ name then strcat .tell
  begin
   prog includelist temp @ REF-next temp !
   prog excludelist temp2 @ REF-next temp2 !
   "    "
   temp @ #-1 dbcmp temp2 @ #-1 dbcmp AND not while
   temp @ #-1 dbcmp if "" else temp @ name then strcat 40 pad
   temp2 @ #-1 dbcmp if "" else temp2 @ name then strcat .tell
  repeat 
;
 
: main
  STRIP
  dup not if
   me @ iswiz? not if pop do-request exit then
  then
  dup "#req" stringpfx 1 = if pop do-request exit then
  dup "unprocessedrequests" strcmp not if pop warn-unproc exit then
 
  dup "#info" stringpfx 1 = if 5 strcut swap pop STRIP
   me @ iswiz? not if "This is for wizzes only. To request a character, type @request" .tell exit then
   dup not over " " explode swap pop 1 > OR 
   if pop "Wrong parameter count! Check @request #help2!" .tell exit then
   "" "#" SUBST atoi showinfo exit 
  then
 
  dup "#delete" stringpfx 1 = if 7 strcut swap pop STRIP
   me @ admin? not if "This function is only usable by the admins of this muck. HANDS OFF!" .tell exit then
   dup not over " " explode swap pop 1 > OR 
   if pop "Wrong parameter count! Check @request #help2!" .tell exit then
   "" "#" SUBST atoi delinfo exit 
  then
 
  dup "#include" stringpfx 1 = if 8 strcut swap pop STRIP
   me @ admin? not if 
    "This function is only usable by the admins of this muck. HANDS OFF!" .tell
    exit 
   then
   dup not over " " explode swap pop 1 > OR
   if pop "Wrong parameter count! Check @request #help3!" .tell exit then
   addtolist exit
  then
 
   dup "#exclude" stringpfx 1 = if 8 strcut swap pop STRIP
   me @ admin? not if
    "This function is only usable by the admins of this muck. HANDS OFF!" .tell
    exit
   then
   dup not over " " explode swap pop 1 > OR
   if pop "Wrong parameter count! Check @request #help3!" .tell exit then
   delfromlist exit
  then
 
  dup "#create" stringpfx 1 = if 7 strcut swap pop STRIP
   me @ iswiz? not if "This is for wizzes only. To request a character, type @request" .tell exit then
   dup not over " " explode swap pop 1 > OR
   if pop "Wrong parameter count! Check @request #help2!" .tell exit then
   "" "#" SUBST atoi do-create exit
  then
 
  dup "#list" stringpfx 1 = if 
   me @ "W" flag? not if 
    "This is for wizzes only. To request a character, type @request" .tell exit 
   then
   showlist exit
  then
  
  dup "#deny" stringpfx 1 = if 5 strcut swap pop STRIP
  me @ iswiz? not if "This is for wizzes only. To request a character, type @request" .tell exit then
   dup not over " " explode swap pop 1 > OR
   if pop "Wrong parameter count! Check @request #help2!" .tell exit then
   "" "#" SUBST atoi do-deny exit
  then
 
  dup "#help2" stringcmp not if
   pop
   me @ iswiz? not if
    "This is for wizzes only. To request a character, type @request" .tell
    exit
   then
   help2 exit
  then
 
  dup "#help3" stringcmp not if
   pop
   me @ admin? not if
    "This is for admins only. To request a character, type @request" .tell
    exit
   then
   help3 exit
  then
 
  dup "#new" stringcmp not if
   pop
   me @ iswiz? not if
    "This is for wizzes only. To request a character, type @request" .tell
    exit
   then
   shownew exit
  then
 
  dup "#old" stringcmp not if
   pop
   me @ iswiz? not if
    "This is for wizzes only. To request a character, type @request" .tell
    exit
   then
   showold exit
  then
  pop
  help1
;

