( cmd-laston -- Records and displays last login time.
   
Vers Date       Notes
1.00 ??/??/??   Originally written by John Boelter {Nightwind@FurryMUCK}
                Adapted for global use by Kimi with much help from Nightwind.
 
                Some routines swiped from cmd-page and gen-mesgboard,
                both written by and credited to Foxen.
  
2.00 06/02/97   Added laston #watchfor, changed flow of code in places
                to be cleaner, added functionality of lastoff.
2.01 06/16/97   Added a #discon toggle to switch between seeing the
                disconnects, and not seeing them.  Useful for if you
                have a longer format string for connects, more room.
                Cleaned up #help screen a bit, added version prop.
2.10 04/19/00   Added another way to display laston times, as it is
                done on SPR, hence the introduction of the SPR-FORMAT
                define. Comment it out if you want the old style.
)
   
$include $lib/strings
 
$def HIDEDISCONS "_prefs/laston/hide_disconnects?"
$def LOOKUP_COST 0
$def TELL me @ swap notify
$def TIME_PROP_OFF "@/lastoff"
$def TIME_PROP_ON "@/laston"
$def VERSIONPROP "_version"
$def WATCHPROP "_prefs/con_announce_list"
$def SPR-FORMAT 1     (comment this out if you want the old laston style)
   
$define get_day "%j %Y" swap timefmt " " .split atoi 1993 -
                365 * swap atoi + $enddef
 
lvar doall
lvar target
lvar good
lvar bad
  
: do-pmatch ( s -- d )
   me @ pennies 10000 < me @ "Wizard" flag? not and if
      me @ LOOKUP_COST addpennies
   then
   .pmatch
;
  
: pad  ( s i -- s' )
   swap "                                        " strcat swap strcut pop
;
  
: done ">> Done." TELL ;
  
: getlastoff ( d -- i )
  TIME_PROP_OFF getpropstr dup if atoi else pop -1 then
;
 
: getlaston ( d -- i )
  TIME_PROP_ON getpropstr dup if atoi else pop -1 then
;
 
: hiding-discons?  ( -- bool )
   me @ HIDEDISCONS getprop
;
  
: setlaston ( s -- )
  "Connect" strcmp not if TIME_PROP_ON else TIME_PROP_OFF then
  me @ swap systime intostr setprop
;
      
: single-space (s -- s') (strips all multiple spaces down to a single space)
   dup "  " instr not if exit then
   " " "  " subst single-space
;
  
: comma-format (string -- formattedstring)
   strip single-space
   ", " " " subst
   dup ", " rinstr dup if
       1 - strcut 2 strcut
       swap pop " and "
       swap strcat strcat
   else pop
   then
;
 
( Commented out for being outdated
: convert-timestamp 
  dup timestamps pop swap pop swap pop intostr
  "@/laston" swap 0 addprop
;
 
: laston-conversion
  "Conversion of all players to @/laston format will, if cmd-laston is" TELL
  "in use already, will, very likely, *seriously* mess up all recorded" TELL
  "@/laston times. Are you sure you wish to run a full conversion?" TELL
  read .yes? not if exit then 
  #0
  begin
    int 1 + dbref
    dup dbtop dbcmp if pop break then
    dup player? not if continue then
    dup convert-timestamp
    dup name TELL
  repeat
  done
;
End of commented out section )
 
: headers ( -- )  
   hiding-discons? if
"Name              Laston             Last Connected"
   else
"Name              Laston             Last Connected    Last Disconnected"
   then TELL
"---------------------------------------------------------------------------"
   TELL
; 
$ifndef SPR-FORMAT   
: transform ( d [player] -- s [X days/weeks ago] )
   getlaston get_day      
   systime get_day swap -      
   dup 7 <
   if         
      dup not
      if
         pop "Today"         
      else dup 1 =
         if
            pop "Yesterday"            
         else
            intostr " days ago" strcat            
         then         
      then      
   else
      7 / dup 1 =
      if
         pop "Last week"         
      else
         intostr " weeks ago" strcat         
      then      
   then      
;
$else
: intotimeunit ( i [time in seconds] -- s [Xs/Xm/Xh/Xd/Xw] )
  dup 3600 24 7 * * / not if
    dup 3600 24 * / not if
      dup 3600 / not if
        dup 60 / not if
          intostr "s" strcat
        else
          60 / intostr "m" strcat
        then
      else
        3600 / intostr "h" strcat
      then
    else
      3600 24 * / intostr "d" strcat
    then
  else
    3600 24 7 * * / intostr "w" strcat
  then 
;
 
: transform ( d [player] -- s [X time ago for Y time] )
  dup getlaston
  systime swap -
  intotimeunit " ago for " strcat
  swap dup getlastoff 
  swap getlaston -
  intotimeunit strcat
;
$endif
 
: laston ( d[player] -- ) 
   dup name 18 pad
   over getlaston dup -1 = if
      pop "--- NEVER CONNECTED ---" strcat TELL pop exit
   then
   3 pick awake? if
      pop "--- ONLINE ---                       " strcat
   else
      swap 
$ifndef SPR-FORMAT
      "( " strcat 3 pick transform strcat " )" strcat
$else
      3 pick transform strcat
$endif
      37 pad
      me @ "_laston/format" getpropstr dup not if pop "%I:%M%p %x" then 
      rot timefmt strcat "  " strcat
   then
   hiding-discons? if TELL pop exit then
   swap getlastoff dup -1 = if
      pop "--- Unknown? ---" strcat
   else
      me @ "_laston/format" getpropstr dup not if pop "%I:%M%p %x" then
      swap timefmt strcat
   then
   TELL 
; 
 
: cycle  ( bool -- )
   ( bool is true if this should cycle all the way through the database )
   ( bool is false if just #weekly is to be done instead )
   headers 
   dbtop int begin dup while
      1 -
      dup dbref dup player? if 
         3 pick if laston continue then
         dup getlaston systime swap - 604800 <= if
            laston 
         else
            pop
         then
      else 
         pop 
      then 
   repeat pop 
;
 
: multi-name ( s -- )
   "" good !
   "" bad !
   single-space
   " " explode
   begin
      dup 0 = if pop break then
      swap dup do-pmatch ok?
      if " " strcat good @ swap strcat good !
      else " " strcat bad @ swap strcat bad !
      then
      1 -
   repeat
   bad @ strip bad !
   good @ strip good !
   bad @ dup .blank? not
   if
      comma-format dup " " instr
      "Could not find the player"
      swap if "s" strcat then
      " named " strcat swap strcat "." strcat
      TELL
   else
      pop
   then
   good @ dup .blank? if pop exit then
   "yes" doall !
   headers
   " " explode
   begin
      dup 0 = if pop break then
      swap do-pmatch laston
      1 -
   repeat
   done
;
  
: laston-watchfor
   me @ WATCHPROP getpropstr multi-name
;
  
: disconnect-toggle  ( -- )
   me @ HIDEDISCONS getprop dup if
      me @ HIDEDISCONS remove_prop
      ">> Disconnect times will now show up on your laston lines." TELL
   else
      me @ HIDEDISCONS "y" setprop
      ">> You will no longer see disconnect times on your laston lines."
      TELL
   then
;
 
: full-authorized? ( -- i )
   me @ "W" flag?
   prog "_authorized" getpropstr
   "#" me @ intostr strcat instr
   or
;
    
: list-help  ( -- )
   prog name " -- authored by " strcat prog owner name strcat 
   " -- Version " strcat prog VERSIONPROP getprop dup not if 
   pop "?.??" then strcat TELL
   "-------------------------------------------------------------------------"
   TELL
   "Usage: '" command @ strcat " <names>'." strcat TELL
   "       '" command @ strcat
      " #watchfor' will do a laston for all names in your" strcat
      " watchfor list." strcat TELL
   "       '" command @ strcat
      " #disconnect' will toggle seeing/not seeing disconnect times."
      strcat TELL
   full-authorized?
   if
      "<names> can be replaced with '#weekly' or '#all', to get" TELL
      "A listing of all players connected within the last week," TELL
      "or a listing of all players, respectively." TELL
   then
   " " TELL
   "To set your own format for listing laston times, use" TELL
   "'@set me=_laston/format:<format string>'." TELL
   "Format strings can be found in 'man timefmt'. Example:" TELL
   "'@set me=_laston/format:%I:%M %p on %d %b %y' will make it so that" TELL
   "you receive formats similiar to '8:30 AM on 02 APR 93'." TELL
   "Warning: If you set your own format, your line may screenwrap in" TELL
   "odd ways.  Try using '" command @ strcat " #disconnect' to fix." 
   strcat TELL
;
 
: main ( s -- )
   command @ "Queued event." strcmp not if setlaston exit then
   strip dup not if "'Laston #help' for help." TELL exit then
   dup "#" 1 strncmp not if
      tolower
      dup "#dis" 4 strncmp not if pop disconnect-toggle exit then
      dup "#wat" 4 strncmp not if pop laston-watchfor exit then
      full-authorized?
      if
         dup "#all" 4 strncmp not if pop 1 cycle done exit then
         dup "#wee" 4 strncmp not if pop 0 cycle done exit then
(        This is outdated, so is being commented out )
(        dup "#con" 4 strncmp not if pop laston-conversion   done exit then )
      then
   pop list-help exit
   else
      dup " " instr if multi-name exit then
      dup do-pmatch dup
      if
         "yes" doall !
         headers
         swap pop laston
      else
         pop
         "Could not find the player named " swap strcat "." strcat TELL
      then
   then
;
 
PUBLIC laston
PUBLIC getlaston
PUBLIC getlastoff

