(
  LinkTo.muf     by Gyroplast  03/06/99
 
  Determine what is linked to your objects
 
  SETUP:
 
    Needed flags: 3,L
    Create an action and link it to the prog.
    You're done!
 
  Usage and parameters are described in #help and #help2
  Have phun!
 
  The author may not be held responsible for data loss
  or any other problems that may occur when using this
  program. Please send bug reports, suggestions, flames,
  porting requests, treats, money or fanmail to:
  gyroplast@wtal.de
)
 
$def bitset? -1 * bitshift 1 bitand
 
lvar target
lvar count
lvar type
(
 type is used to specify the search flags:
   bit 0 - exit
   bit 1 - player
   bit 2 - thing
   bit 3 - room
)
 
: scan ( -- )
  "Objects linked to " target @ name strcat
  "(#" strcat target @ intostr strcat ") :" strcat .tell
  0 count !
  0
  BEGIN
   dup dbref dbtop dbcmp not while
   dup dbref
   dup ok? if
    0 over
    type @ 0 bitset? if exit? OR over then
    type @ 1 bitset? if player? OR over then
    type @ 2 bitset? if thing? OR over then
    type @ 3 bitset? if room? OR over then
    dup program? not if getlink target @ dbcmp AND else pop 0 AND then
  ( if object matches search pattern... )
    if
     dup name
     ( Extended info for wizzes and owners )
     over owner me @ dbcmp me @ "W" flag? OR if
      "(#" strcat
      over intostr strcat
      over player? if "P" strcat then
      over room? if "R" strcat then
      over exit? if "E" strcat then
      over "Truewizard" flag? if "W" strcat then
      over "L" flag? if "L" strcat then
      over "K" flag? if "K" strcat then
      over "D" flag? if "D" strcat then
      over "S" flag? if "S" strcat then
      over "Q" flag? if "Q" strcat then
      over "B" flag? if "B" strcat then
      over "C" flag? if "C" strcat then
      over "J" flag? if "J" strcat then
      over "H" flag? if "H" strcat then
      over "A" flag? if "A" strcat then
      over "V" flag? if "V" strcat then
      over "Z" flag? if "Z" strcat then
      over mlevel dup if intostr "M" swap strcat strcat else pop then
      ")" strcat
     then
     .tell
     count @ 1 + count !
    then
    pop
   else
    pop
   then
  1 +
  REPEAT
  pop
  "***End of List***" .tell
  count @ intostr " objects found." strcat .tell
;
 
: getflags
  0
  over "E" instring if 1 + then
  over "P" instring if 2 + then
  over "T" instring if 4 + then
  over "R" instring if 8 + then
  swap pop
  dup not if pop 255 then
;
 
: help
  "LinkTo v1.0   <HELP>" .tell
  "***********" .tell
  "  List all objects linked to a specified object you own." .tell
  " " .tell
  "  Syntax: " trig name toupper strcat " <object>[=<object types>]" strcat .tell
  " " .tell
  "  Valid object types are:" .tell
  "    P  -  Players;  R  -  Rooms;  E  -  Exits;  T  -  Things;" .tell
  " " .tell
  "  When <object types> is omitted, all types will be shown." .tell
  "  If you're not a wizard, you must own the <object> you want to inspect." .tell
  " " .tell
  "  Example: " trig name toupper strcat " me=ET" strcat .tell
  "  This shows a list of all exits and things linked to yourself." .tell
;
 
: extractargs ( s -- i )
  "=" explode
  dup 2 > if pop help 1 exit then
  1 = if "" swap then
  dup not if pop help 1 exit then
  dup match dup #-1 dbcmp if
   pop
   "" "#" subst
   atoi dbref
  else
   swap pop
  then
  target !
 
  getflags
  type !
  0
;
 
: main
  STRIP
  dup "#h" instring over not OR if pop help exit then
  extractargs not if
   target @ owner me @ dbcmp me @ "W" flag? OR if
    scan
   else
    "You do not own that object, or object does not exist!" .tell
   then
  then
;

