( movie.muf  --  10/30/92  by Squirrelly )
(
    INTRODUCTION TO MOVIE.MUF.
    This program is useful where you'd like a series of messages to be
    displayed to an entire room, with the option of controlling the
    timing of those messages.  With this you could create things such as
    a movie theater, radio, tape/CD player, or even special effects for
    a room.
    
    QUICKY SET-UP.
    The straightforward simplest way to set this up is to create an
    action, link it to this program, use lsedit to create the 'movie'
    {explained below} on the list _movie/line on the action {e.g.,
    'lsedit <action>=_movie/line'}, and set movie/stat:stop on the
    action {must be set to that for it to start}.  That's it.  Then
    you'd just type the action and it would start, running to its end.
    However, it can be set up many more diffent ways, to meet other
    needs or desired effects.
    
    WHAT GOES INTO A MOVIE'S LIST?  and  IN-LINE #COMMANDS.
    What goes in is very simply what you want displayed in the room.
    Each line of text in the list is normally sent straight to the
    room as is.  But this would make a very poor 'movie' just to have
    a pile of data spewed out.  So to this end, we have a number of
    'commands' you can insert into the movie too.  Each command must
    be on a line of its own, with the #-sign at the start of the line.
    Here is a list of currently available in-line movie commands:
        #defpause <seconds>
        #pause <seconds>
        #prefix <text>
        #output [<destinations>]
        #echo <message>
        #run <listname> [<line range>]
        #call <program> <passed text>
        #nop [<text>]
        #end [<message>]
        #stop [<message>]
    And here is a bit of an explanation for each of the above:
    #defpause -- How many <seconds> to wait between each line of
        displayed text if a #pause has not been given since the
        previous line out output.  This is initally set to 0 {zero}.
    #pause -- A one-time wait of any number of <seconds> at any point
        in the moive.  Instead of using #defpause and having it all
        displayed at one monotonous pace, have it show a few lines or
        entire paragraphs if describing scenes or what not, and place
        bigger pauses between each of these with the #pause command.
        Takes a little more work but this can make your movies much
        dynamic and interactive feeling, and thus making them more
        interesting and hopefully more enjoyable.
    #prefix -- Simply causes <text> to be displayed at the front of
        every line there after.  It can be any text you like.
    #output -- Causes the output to be redirected to the target or
        targets given as <destinations>.  If it is not owned by the
        owner of the action that stared this movie or the person that
        did so, the output may be prepended with ">> " based on spoofing
        permissions of the room, and also must be 'nearby.'  Some
        special destinations and their meanings are:
          here  - [Default Value]  Sends output to the room the person
                  was in when they started the movie.
          me    - Sends output just to the person running the movie.
          me@   - Sends output to the person running the movie and the
                  room that they are currently in.
          this@ - Sends output to the room that the starting action is
                  in.  Might be good for a 'portable radio' for example.
        Multiple destinations should be space separated.
    #echo -- Display the given <message> to the person that started
        the movie, as opposed to the entire room.
    #run -- Causes the current movie to temporarily pause and the movie
        <listname> to be run.  The optional <line range> can restrict
        the playing to just a part of the selected movie, and is either
        just the starting line number, in which case it will run from
        there to the end, or of the form <start>-<end>, in which case
        it will run from line <start> to line <end>.
    #call -- Will allow you to run other programs from the movie
        program, giving control of their timing.  <program> is the
        #<dbref> of the program to run, and <passed text> is the data
        given to that program when it starts.
    #nop -- No Operation.  Basicly, any given <text> is ignored.  Good
        for comments or MPI code where you wish to discard anything
        returned.
    #end -- Make the current movie stop running, going back to the
        movie that started this one with #run, if such is the case.
        This is about the same as reaching the end of the movie list,
        but allowing you cause it to occur before that.  The optional
        <message> will be displayed to the one who started the movie.
        This could be to tell them to start the next one, or just to
        let them know it has finished.
    #stop -- Make the movie come to a complete stop, even if this one
        was #run by another.  Again, an optional <message> can be
        displayed to the operator.
    
    COMMAND-LINE OPTIONS.
    These are commands you can give after the action's name when you
    run it.  Here is the list of them and what they do:
        #help    -- Standard help screen, with summery information
                    available for these command-line options, in-line
                    commands, and properties that can be set.
        #stop    -- Cause the movie to quit running.
        #reset   -- Resets running properties to their default,
                    start-up values.
        #resume  -- Resume running of a movie that was #stop'ed.
        <movie name>  -- Play a selected movie instead of the default
                         one.  See movie/sel/<name> under PROPERTIES
                         for more information.
    
    PROPERTIES.
    These are items you can set on the action [or the proploc if used]
    and in its enviroment.  The props are of the form movie/<field>
    and an underscore {'_'} can be optionally placed before the word
    'movie' [i.e. _movie/<field>] and/or before the <field> [i.e.
    movie/_<field>] to make them protected fields.  If you don't
    understand what that means it's not important and they can all
    just be left out.  The <field>s that you can set and what they
    do are listed below here:
        movie/proploc  -- A dbref of where to find any of the remaining
                          properties and the movie lists.
        movie/list  -- This is the name of the starting 'movie' this
                       action is to look for.  That is, this prop has
                       the *name of a list* which should have been
                       created with lsedit.  The default value of this,
                       if not given, is '_movie/line'.
        movie/room  -- This sets where the output of this is to go [at
                       least initally].  It is very much like the
                       '#output' option under IN-LINE #COMMANDS, but
                       would be the starting default for all 'movies'
                       available under it.  This can be useful for like
                       a separate projection booth from where the
                       actual output is viewed, such as a theater room.
                       The default is basicly the location of the
                       person starting it.
        movie/stat  -- Must be set to 'stop' for a moive to be able to
                       start.  The program will then set it to 'run'
                       while one is running and set it back to 'stop'
                       when done.  If this field is set to 'stop' or
                       anything other than 'run' while a moive is
                       going, the moive will quit running.  NOTE: This
                       should _not_ be a protected field if anyone
                       other than the owner is to use this action.
        movie/sel/<name>  -- Sorta like movie/list, but if a <name> is
                       typed with the action to start the movie, it
                       will use the *list name* this is set to.  [e.g.,
                       if your action linked to this program is 'play'
                       and the person typed 'play jaws', then if you
                       had movie/sel/jaws set to a list name, it would
                       play that movie it points to.]  If a <name> is
                       entered but not set here, then if movie/list is set,
                       that will be used as the default, and if not set, a
                       'Bad selection' error will be given to the user.
        movie/forground -- If set 'yes', will make the movie run in the
                       forground instead of background as usual, meaning
                       the player starting it will have to wait until it
                       finishes running to give another command.  Be
                       careful not to abuse this.  Using the command @Q
                       can still abort you out of a program running this
                       way.
        movie/frame  -- Normally this is not something you set, but is
                        set by the program.  It is the line of the list
                        at which the movie last stopped, and is there
                        for the #resume feature.  For the same reasons
                        as movie/stat, this should not be a protected
                        field normally, if you happen to be setting it
                        manually for some reason.
    
    EXAMPLE SET-UP.
        Here are a couple of examples you can use.  Lists' contents
        are indented solely to help them stand out.
 
        First example:  A simple set-up; special effects.
            @open push button=#<db of movie.muf>
            @set push button=movie/stat:stop
            push button #reset
            lsedit push button=_movie/line
              #defpause 6
              {name:me} pushes the button on the wall, opening a pannel.
              A large SuperBall shoots out from the open pannel!
              The ball zips past {name:me}, bouncing off the far wall!
              The SuperBall ricochets off the coat rack then hits the
              #pause 0
              the picture, sending it in a high arch across the room!
              The ball comes down, arching perfectly into an open
              #pause 0
              funnel and vanishes back into the wall.
              The pannel closes back up.
            .end
 
        Second example:  A portable CD player.
            @create CD Player
            @act play=player
            @link play=#<db of movie.muf>
            @set play=movie/stat:stop
            play #reset
            @set play=_movie/room:this@
            @set play=_movie/list:_CD/index
            @set play=_movie/sel/rock:_CD/rock
            @set play=_movie/sel/clasic:_CD/clasic
            lsedit play=_CD/index
              #output me
              You can 'play' the following CDs:
              "rock"   - It's only Rock'n'Roll, but I like it!
              "clasic" - Relax and enjoy.
            .end
            lsedit play=_CD/rock
              #prefix On the CD Player, 
              #defpause 12
              A drum beat picks up with a rising crescendo.
              Electric guitars join the strong drum beat.
              The singer joins in, his loud voice shattering a glass!
              ....etc....
            .end
            lsedit play=_CD/clasic
              #prefix On the CD Player, 
              A quiet, crystal clear flute breaks the silence..
              #pause 10
              The single note rises in volume, then starts to wander
              the scales like a slowly soaring bird as several violins
              join ever so softly to the background.
              #pause 20
              The music seems to drift along, taking you with it..
              ....etc....
            .end
)
 
$include $lib/lmgr
$include $wfdesc
 
$ifndef lib-eval $def lib-eval ME @ swap pronoun_sub $endif
 
lvar PARAM
lvar STATPLOC
lvar PLOC
lvar LISTNAME
lvar FRAME
lvar OUTPUT
lvar DEFPAUSE
lvar PREFIX
lvar LASTPAUSE
lvar RM_ADDR
 
$def .wizmatch #5895 CALL
$def .safecall #5896 CALL
: nl-repl
  prog
  "_nl" getpropstr subst
;
 
: .smatch  ( s s -- i )
   over if smatch else pop pop 0 then
;
 
: getmovieprop  ( d s -- s )
    over over "_movie/_" swap strcat .envprop dup not if
        pop over over "_movie/" swap strcat .envprop dup not if
        pop over over "movie/_" swap strcat .envprop dup not if
        pop over over "_movie_" swap strcat .envprop dup not if
        pop over over "movie/" swap strcat .envprop dup not if
        pop over over "movie_" swap strcat .envprop
    then then then then then
    swap pop swap pop
;
 
: checkfor  ( d s s -- d s s d )
    3 pick over 4 pick strcat .envsearch
;
 
: addmovieprop  ( d s s -- )
    rot rot
    "_movie/_" checkfor dup not if
        pop pop "_movie/" checkfor dup not if
        pop pop "movie/_" checkfor dup not if
        pop pop "_movie_" checkfor dup not if
        pop pop "movie/" checkfor dup not if
        pop pop "movie_" checkfor
    then then then then then
    ( s-val d-orig s-field s-prefix d-found )
    dup if
        swap rot strcat 4 rotate 0 addprop
        pop
    else
        pop pop "movie/" swap strcat rot 0 addprop
    then
;
 
: fix_lname  ( s -- s )
    dup dup strlen
    dup 3 < if pop pop exit then
    2 - strcut "#/" strcmp if pop else swap pop then
;
 
: movie-getelem  ( i s d -- s )
    prog mlevel 3 < if
        .lmgr-getelem
        exit
    then
    swap rot intostr
    3 pick 3 pick "#/" strcat 3 pick strcat
    COMMAND @ 1 parseprop
    dup if -4 rotate pop pop pop exit then
    pop strcat COMMAND @ 1 parseprop
;
 
: get_frame  ( d s i -- s )
    begin
        3 pick while
        dup 3 pick 5 pick
        movie-getelem
         "%;" nl-repl
        dup if
            -4 rotate pop pop pop exit
        then
        pop rot location rot rot
    repeat
    pop pop pop ""
;
 
: output_frame  ( s -- i )
    1 swap OUTPUT @
    begin
        dup while
        " " .split swap strip
        (me@=location of starter, me=starter only,
         here=room started in, this@=location of trigger)
        dup "me@" .smatch if
            pop ME @ location
        else dup "me" .smatch if
            pop ME @
        else dup "here" .smatch if
            pop LOC @
        else dup "this@" .smatch if
            pop TRIGGER @ room? if
                TRIGGER @
            else TRIGGER @ exit? if
                TRIGGER @ location
                dup room? not if location then
            else
                TRIGGER @ location
            then then
        else
            .atodbref
        then then then then
        dup ok? if
            TRIGGER @ over controls over ME @ swap controls or if
                0 4 pick notify_exclude
                0 3 put
            else dup TRIGGER @ location dbcmp
             over TRIGGER @ location location dbcmp or
             over ME @ location dbcmp or not if
                pop
            else dup "_puppet_ok?" .envprop "yes" .smatch
             4 pick " " .split pop dup .pmatch-f ok? not
             swap dup ME @ owner name stringcmp not
             swap TRIGGER @ owner name stringcmp not or or and if
                0 4 pick notify_exclude
                0 3 put
            else
                0 ">> " 5 pick strcat notify_exclude
                0 3 put
            then then then
        else
            pop
        then
    repeat
    pop pop
;
 
: do_frame  ( s -- i )
    0 swap
    dup "#" 1 strncmp not if
        " " .split
        swap
        dup "#pause" strcmp not if
            pop atoi dup 0 > if sleep else pop then
            1 LASTPAUSE !
            exit
        then
        dup "#call" strcmp not if
            pop " " .split
            swap .wizmatch
            1 .safecall
            exit
        then
        dup "#defpause" strcmp not if
            pop atoi dup 0 < if pop 0 then
            DEFPAUSE !
            exit
        then
        dup "#prefix" strcmp not if
            pop PREFIX !
            exit
        then
        dup "#output" strcmp not if
            pop dup not if pop "here" then
            OUTPUT !
            exit
        then
        dup "#run" strcmp not if
            pop " " .split swap fix_lname swap
            "-" .split
            swap strip atoi dup 1 < if pop 1 then
            swap strip atoi dup 0 < if pop 0 then
            $ifdef __muckname=FurryMUCK
              PLOC @ 4 pick "#" strcat .envsearch
              dup if 4 pick .fixlist then pop
            $endif
            RM_ADDR @ execute
            exit
        then
        dup "#echo" strcmp not if
            pop .tell
            exit
        then
        dup "#nop" strcmp not if
            pop pop exit
        then
        dup "#end" strcmp not if
            pop dup if .tell else pop then
            pop 1 exit
        then
        dup "#stop" strcmp not if
            pop dup if .tell else pop then
            PLOC @ "stat" "stop" addmovieprop
            pop 1 exit
        then
        " " strcat swap strcat
    then
    PREFIX @ swap strcat
    LASTPAUSE @ not if DEFPAUSE @ if DEFPAUSE @ sleep then then
    output_frame if
        "Movie:  No valid output destination selected." .tell
        pop 1
    then
    0 LASTPAUSE !
;
 
: eval_frame  ( s -- i )
    dup not if do_frame exit then
    lib-eval
    begin
        dup while
        "%;" .split swap
        do_frame if pop 1 exit then
    repeat
    pop 0
;
 
: run_movie  ( s i i -- )   ( list-name start max-or-0 )
    begin
        over over <= over not or while
        PLOC @ 4 pick 4 pick get_frame
        dup not if
            4 pick PLOC @ .lmgr-getcount
            4 pick < if pop break then
        then
        eval_frame if
            PLOC @ "frame" 4 pick intostr addmovieprop
            pop pop pop exit
        then
        swap 1 + swap
        PLOC @ "stat" getmovieprop
        "run" strcmp if
            PLOC @ "frame" 4 pick intostr addmovieprop
            PLOC @ "stop/defpause" DEFPAUSE @ intostr addmovieprop
            PLOC @ "stop/prefix" PREFIX @ addmovieprop
            PLOC @ "stop/output" OUTPUT @ addmovieprop
            pop pop pop exit
        then
    repeat
    pop pop pop
;
 
: main
    dup STRIP not if pop "Please tell me a name for the movie." .tell exit then
    dup PARAM !
    " " .split swap
    "#help" stringcmp if pop else
        dup "command" stringcmp not if
            pop "Movie command-line options:" .tell
            "  #help" .tell
            "  #stop" .tell
            "  #reset" .tell
            "  #resume" .tell
            "  <movie name>" .tell
            exit
        then
        dup "in-line" stringcmp not if
            pop "Movie in-line commands:" .tell
            "  #defpause <seconds>" .tell
            "  #pause <seconds>" .tell
            "  #prefix <text>" .tell
            "  #output [<destinations>]" .tell
            "  #echo <message>" .tell
            "  #run <listname> [<line range>]" .tell
            "  #call <program> <passed text>" .tell
            "  #nop [<text>]" .tell
            "  #end [<message>]" .tell
            "  #stop [<message>]" .tell
            "  <movie text>" .tell
            exit
        then
        dup "props" stringcmp not if
            pop "Movie properties that can be set:" .tell
            "  movie/proploc" .tell
            "  movie/list" .tell
            "  movie/room" .tell
            "  movie/stat" .tell
            "  movie/sel/<name>" .tell
            exit
        then
        pop "_Movie.muf  10/30/92  by Squirrelly_" .tell
        COMMAND @ " help:" strcat .tell
        "  " COMMAND @ strcat " #help " strcat
        dup "         -- This information." strcat .tell
        dup "command  -- Display command-line options." strcat .tell
        dup "in-line  -- Movie in-line commands available." strcat .tell
        "props    -- Properties that can be set." strcat .tell
        "Type '@view #" prog intostr strcat
        "' for complete help and information" strcat .tell
        exit
    then
    TRIGGER @ "proploc" getmovieprop
    dup not if
        pop TRIGGER @
    else
        .atodbref
        TRIGGER @ over controls not
         over "_proploc_ok?" getpropstr "yes" strcmp and
        if
            "Movie:  proploc owner does not match -- Aborted." .tell
            exit
        then
    then
    PLOC !
    ( check for any special invoking #commands here )
    PARAM @ " " .split swap
    dup "#stop" stringcmp not if
        PLOC @ "stat" "stop" addmovieprop
        COMMAND @ ": --stopping--" strcat .tell
        pop pop exit
    then
    "#reset" stringcmp not if
        PLOC @ "stat" "stop" addmovieprop
        PLOC @ "frame" "1" addmovieprop
        COMMAND @ ": --resetting--" strcat .tell
        pop exit
    then
    pop
    PLOC @ "forground" getmovieprop
    "yes" stringcmp if background then
    PLOC @ "stat" getmovieprop
    "stop" strcmp if
        COMMAND @ "Queued event." strcmp if
            COMMAND @ ": Movie already in progress." strcat .tell
        then
        exit
    then
    PLOC @ "stat" "run" addmovieprop
    PLOC @ "list" getmovieprop
    dup "" strcmp not if
        pop "_movie/line"
    then
    fix_lname
    LISTNAME !
    PLOC @ "room" getmovieprop
    dup not if pop "here" then
    OUTPUT !
    0 DEFPAUSE !
    0 LASTPAUSE !
    "" PREFIX !
    1 FRAME !
    'run_movie RM_ADDR !
    PARAM @ " " .split pop
    "#resume" stringcmp not if
        PLOC @ "framer" getmovieprop
        dup if LISTNAME ! else pop then
        PLOC @ "frame" getmovieprop
        atoi 1 - dup 1 < if pop 1 then
        FRAME !
        PLOC @ "stop/defpause" getmovieprop atoi DEFPAUSE !
        PLOC @ "stop/prefix" getmovieprop PREFIX !
        PLOC @ "stop/output" getmovieprop
        dup if OUTPUT ! else pop then
        COMMAND @ ": resuming..." strcat .tell
        "" PARAM !
    else PARAM @ "#" 1 strncmp not if
        COMMAND @ ":  Invalid command-line option." strcat .tell
        "Type '" COMMAND @ strcat " #help' for help." strcat .tell
        PLOC @ "stat" "stop" addmovieprop
        exit
    then then
    PARAM @ if
        PLOC @ "sel/" PARAM @ strcat getmovieprop
        dup if
            LISTNAME !
        else
            PLOC @ "list" getmovieprop not if
                COMMAND @ ":  Invalid selection." strcat .tell
                "Sorry, that selection was not found." .tell
                PLOC @ "stat" "stop" addmovieprop
                pop exit
            then
            pop
        then
    then
    $ifdef __muckname=FurryMUCK
      PLOC @ LISTNAME @ "#" strcat .envsearch
      dup if LISTNAME @ .fixlist then pop
    $endif
    PLOC @ "framer" LISTNAME @ addmovieprop
    LISTNAME @ FRAME @ 0
    run_movie
    PLOC @ "stat" "stop" addmovieprop
;

