( auction.muf     by Gyroplast   04/17/99
  
  A program to sell furs for the highest bid.
  Sounds like an auction to you? Well, it is.
  Setup:
    1. Create an auction hall or something.
    2. Create an action called 
       auction;setbid;bid;setop;nextpet;makesell;credits;sellme;setpref;setcur
       on the hall and link it to this program.
       Every action you want to have elsewhere, but refer to the auction
       hold in the hall you built, need to have a property set containing
       the dbref of the hall. Example:
       If you want to see how many credits you have, you create an action
       with the db number #1234 somewhere, and link it to the prog.
       The auction hall has a dbref of #5678.
       Then you have to type '@set #1234=_storeloc:5678' to make it work.
    3. Read auction #help!
    4. Have phun!
  Permission to port is hereby granted. Questions, comments, flames or
  anything else go to gyroplast@yahoo.com or directly to me on
  FuzzyLogic. Please make only NECESSARY changes.
  
)
 
$def DEFCUR "auction dollars"
$def STORELOC trig "_storeloc" getpropstr atoi dup not if pop trig location else dbref then
$def SOLDPROP "_prefs/sold?"
$def PREFPROP "_subprefs"
$def STARTPROP "_started?"
$def AUCTIONER "_auctioner"
$def BIDPROP "_highbid"
$def LASTBIDPROP "_lastbid"
$def CREDITS "_creds/"
$def CURPROP "_currency"
$def WHOIS4SALE "_forsale"
 
: getauctioner (  -- d )
  STORELOC AUCTIONER getpropstr atoi dup not if
   pop STORELOC owner
  else
   dbref dup player? over awake? and not if
    pop STORELOC owner
   then
  then
;
 
: isauctioner? ( d -- b )
  getauctioner dbcmp
;
 
: gethighbid (  -- i )
  STORELOC BIDPROP getpropstr atoi
;
 
: getlastbidder (  -- d )
  STORELOC LASTBIDPROP getpropstr dup not if
   pop #-1
  else
   atoi dbref
  then
;
 
: getcred ( d -- i )
  name CREDITS swap strcat
  STORELOC swap getpropstr atoi
;
 
: setcred ( d i --  )
  swap name CREDITS swap strcat
  swap intostr 1 STORELOC -4 rotate addprop
;
 
: getpref ( d -- s )
  PREFPROP getpropstr dup not if
   pop "No preferences set."
  then
;
 
: started? ( -- b )
  STORELOC STARTPROP getpropstr
;
 
: getcurrency ( -- s )
  STORELOC CURPROP getpropstr dup not if
   pop DEFCUR
  then
;
 
: get4sale ( -- d )
  STORELOC WHOIS4SALE getpropstr atoi dbref
;
 
: is4sale? ( d -- b )
  SOLDPROP getpropstr "yes" strcmp not
;
 
: setbid ( i --  )
  intostr STORELOC swap BIDPROP swap 1 ADDPROP
;
 
: setstartbid ( s --  )
  started? if
   pop "The auction has already begun." .tell exit
  then
  
  me @ isauctioner? not if
   pop "You are not the auctioner here." .tell
  else
   atoi
   dup not over 0 < or if
    pop "Please use a numeric value higher than zero." .tell
   else
    dup setbid
    "Bid set to " swap intostr strcat " " strcat
    getcurrency strcat "." strcat .tell
   then
  then
;
 
: newbidproc ( s --  )
  started? not if
   pop "The auction has not started yet!" .tell exit
  then
  me @ get4sale dbcmp if
   pop "You can't bid for yourself!" .tell exit
  then 
  
  atoi dup not over 0 < or if
   pop "Please use a numeric value higher than zero." .tell exit
  then
  
  started? not if
   pop "The auction hasn't started yet!" .tell exit
  then
  
  dup gethighbid + me @ getcred > if
   pop "You cannot afford that." .tell exit
  then
  
  "You increase the bid by " over intostr strcat
  ". It is at " strcat over gethighbid + intostr strcat
  " now!" strcat .tell
  me @ name " increases the bid by " strcat over intostr strcat
  "! It is at " strcat over gethighbid + intostr strcat
  " now." strcat .otell
  gethighbid + setbid
  STORELOC LASTBIDPROP me @ intostr 1 addprop
;
 
: setme4sale ( s --  )
  "yes" stringcmp not  
  if
   me @ SOLDPROP "yes" 1 addprop
   "You are now ready to be sold at the auction!" .tell
   "Use '" command @ strcat " no' to reset." strcat .tell
  else
   me @ SOLDPROP remove_prop
   "Property reset, you will not be sold." .tell
   "Use '" command @ strcat " yes' to set." strcat .tell
  then
;
  
: setpreference ( s --  )
  dup not if
   me @ PREFPROP remove_prop
   "Preference cleared." .tell
  else
   me @ over PREFPROP swap 1 addprop
   "Preference set to: " swap strcat .tell
  then
;
 
: startauction (  --  )
  me @ isauctioner? not if
   pop "You are not the auctioner here." .tell
  else
   get4sale player? not if
    "Choose a pet to sell first." .tell exit
   else   
    STORELOC STARTPROP "yes" 1 addprop
    "Auction started." .tell
   then
  then
;
 
: stopauction (  --  )
  me @ isauctioner? not if
   pop "You are not the auctioner here." .tell
  else
   STORELOC STARTPROP remove_prop
   STORELOC LASTBIDPROP remove_prop
   STORELOC BIDPROP remove_prop
   STORELOC WHOIS4SALE remove_prop
   "Auction stopped." .tell
  then
;
  
: set4sale ( s --  )
  started? if
   pop "You can't do that while an auction is running." .tell exit
  then
  
  me @ isauctioner? not if
   pop "You are not the auctioner here." .tell exit
  then
  
  .pmatch
  dup #-1 dbcmp if
   pop "This fur is not here." .tell exit
  then
  dup #-2 dbcmp if
   pop "Please be more specific, I do not know who you mean." .tell exit
  then
  dup player? not if
   pop "That is not a player." .tell exit
  then
  dup is4sale? not if
   pop "That player does not want to be sold." .tell exit
  then
  
  "Resetting any running auctions..." .tell
  stopauction
  " " .tell
  dup intostr STORELOC swap WHOIS4SALE swap 1 addprop
  name " is subject to be sold now!" strcat .tell
  "Set a starting bid if needed before the auction begins." .tell
;
 
: showcreds (  --  )
  me @ getcred intostr
  "You possess " swap strcat " " strcat
  getcurrency strcat "." strcat .tell
;
 
: sellfur (  --  )
  started? not if
   "No auction running." .tell exit
  then
  
  me @ isauctioner? not if
   pop "You are not the auctioner here." .tell
  else  
   getlastbidder dup getcred gethighbid - setcred
   
   get4sale name " is sold to " strcat
   getlastbidder name strcat " for " strcat
   gethighbid intostr strcat " " strcat
   getcurrency strcat "!" strcat dup
   .tell .otell
   stopauction
  then
;
 
: auctioninfo (  --  )
  " " .tell
  " Auction status: " .tell
  " " .tell
  
  started? not if
   "   No auction running at the moment." .tell
  else
   "   Name of pet : " get4sale name strcat .tell
   "   Preferences : " .tell
   get4sale getpref .tell
   " " .tell
   "   Auctioner   : " getauctioner name strcat .tell
   "   Highest bid : " gethighbid intostr strcat .tell
   "   Last bidder : " 
   getlastbidder dup player? not if pop "No one" else name then
   strcat .tell
   " " .tell
  then
;
 
: setcurrency ( s --  )
  STORELOC swap CURPROP swap 1 addprop
  "Currency is now '" getcurrency strcat "'." strcat .tell
;
 
: setauctioner ( s --  )
  me @ isauctioner? not if
   pop "You are not the auctioner here." .tell exit
  then
  
  .pmatch
  dup #-1 dbcmp if
   pop "This fur is not here." .tell exit
  then
  dup #-2 dbcmp if
   pop "Please be more specific, I do not know who you mean." .tell exit
  then
  dup player? not if
   pop "That is not a player." .tell exit 
  then
  
  intostr STORELOC swap AUCTIONER swap 1 addprop
  getauctioner name " is the auctioner now." strcat dup .tell .otell
;
 
: showhelp
  " AUCTION v1.0   by Gyroplast" .tell
  "-----------------------------" .tell
  " " .tell
  " Auctioner actions:" .tell
  "   auction #start   - Starts the auction"  .tell
  "   auction #stop    - Stops the auction" .tell
  "   setbid <value>   - Sets current bid to <value>" .tell
  "   setop <name>     - Make <name> be the auctioner" .tell
  "   setcur <name>    - Sets the currency to <name>" .tell
  "   nextpet <name>   - Chooses <name> to be the next pet" .tell
  "   makesell         - Sells the pet to the highest bidder" .tell
  " " .tell
  " Pet actions:" .tell
  "   sellme [yes|no]  - Sets yourself as a pet ready to be sold" .tell
  "   setpref <text>   - Sets your preferences to <text>" .tell
  " " .tell
  " General:" .tell
  "   auction #help    - Shows this help screen" .tell
  "   auction #info    - Shows the auction status" .tell
  "   bid <value>      - Increases current bid by <value>"  .tell
  "   credits          - Shows how many credits you have" .tell
  " " .tell
;
 
: main
  strip
  command @ "auction" stringcmp not if
   dup not if pop showhelp exit then
   dup "#sta" stringpfx 1 = if pop startauction exit then
   dup "#sto" stringpfx 1 = if pop stopauction exit then
   dup "#i" stringpfx 1 = if pop auctioninfo exit then
   dup "#h" stringpfx 1 = if pop showhelp exit then
  then
  command @ "setbid" stringcmp not if setstartbid exit then
  command @ "bid" stringcmp not if newbidproc exit then
  command @ "sellme" stringcmp not if setme4sale exit then
  command @ "setpref" stringcmp not if setpreference exit then 
  command @ "makesell" stringcmp not if pop sellfur exit then
  command @ "nextpet" stringcmp not if set4sale exit then
  command @ "setop" stringcmp not if setauctioner exit then
  command @ "setcur" stringcmp not if setcurrency exit then
  command @ "credits" stringcmp not if showcreds exit then
  "Unknown command." .tell
;

