( ListSpec.muf     by Gyroplast   04/15/99
 
  Search for players with specific property settings,
  especially species and gender.
 
  SETUP: 
    1. @set this prog M3
    2. Create an action on #0
    3. Link this action to the program
    4. You're done!
 
  Have phun!            *VuLPeS VeLoXiS '99*
 
  Porting and making NECESSARY changes is allowed.
  Contact gyroplast@wtal.de in case of bugs, and
  check out http://www.gyroplast.com ! :)
 
LVAR tmp
LVAR counter
LVAR andsearch
LVAR scanwholedb
LVAR shieldon
$def VERSION "v1.02"
( Set these $defines to reflect where sex and species of a char is stored. )
$def SPECIESPROP "species"
$def SEXPROP "sex"
$def LINE "----------------------------------------------------------------"
$def killstack BEGIN dup WHILE 1 - swap pop REPEAT pop
$def underline strlen LINE swap strcut pop .tell
 
: getnextplayer ( d -- d')
  dup tmp !
  #-1 dbcmp IF
   online
   1 - swap tmp !
   killstack
   tmp @ EXIT
  THEN
  online
  
  BEGIN
   dup WHILE
   1 - swap
   tmp @ dbcmp IF
    dup IF
     1 - swap tmp ! BREAK
    ELSE
     #-1 tmp !
    THEN
   THEN
  REPEAT
  killstack tmp @
;
 
: getnextplayerfromdb ( d -- d' )
  dup dup tmp !
  BEGIN
   1 +
   dup dbtop dbcmp not WHILE
    dup ok? IF
     dup player? IF
      dup tmp ! BREAK
     THEN
    THEN
  REPEAT
  pop
  tmp @ dbcmp IF #-1 ELSE tmp @ THEN
;
 
: showplayerinfo ( d --  )
  dup name over intostr
  " (#" swap strcat "): " strcat strcat
  over SEXPROP getpropstr 
  dup not IF pop "<no gender>" THEN
  strcat ", " strcat
  swap SPECIESPROP getpropstr
  dup not IF pop "<no species>" THEN
  strcat "   " swap strcat
  .tell
; 
 
: fitcriteria? ( d -- b )
  andsearch @ tmp !
  prog "criteria" getpropstr atoi
  BEGIN
   dup WHILE
   swap over intostr "criteria/" swap strcat
   dup "/name" strcat prog swap getpropstr
   3 pick swap getpropstr
   swap "/value" strcat prog swap getpropstr
   over not IF pop pop 0 ELSE smatch THEN
   tmp @ 
   andsearch @ if and ELSE or THEN
   tmp !
   swap 1 -
  REPEAT
  pop pop
  tmp @
;
 
: dosearch
  " Do you want to search the WHOLE database? (y/n)" .tell
  " Warning! This takes a rather long time!" .tell
  read strip
  dup "y" stringpfx 1 = IF
   pop " You have been warned.. abort with @Q at any time." .tell
   1 scanwholedb !
  ELSE
   pop
  THEN
  
  " " .tell
  "ListSpecies " VERSION strcat "  by Gyroplast" strcat
  dup .tell
  underline
  " " .tell
  " List of players matching your search pattern:" .tell
  " " .tell
  #-1
  BEGIN
   scanwholedb @ IF
    getnextplayerfromdb
   ELSE
    getnextplayer
   THEN
   dup #-1 dbcmp not WHILE
   dup fitcriteria? IF
    counter @ 1 + counter !
    dup showplayerinfo
    counter @ 25 % not shieldon @ AND IF
     " SPAM SHIELD: Type anything to continue..." .tell
     read pop
    THEN
   THEN
  REPEAT
  pop
  
  " " .tell
  counter @ not IF
   " No matches found. Try a different pattern." .tell
  ELSE
   " ListSpecies found " counter @ intostr strcat
   " player(s) matching your query." strcat .tell
  THEN
  prog "criteria" remove_prop
;
 
: doquicksearch ( s --  )
  prog "criteria" "1" 1 addprop
  prog "criteria/1/name" SPECIESPROP 1 addprop
  prog swap "criteria/1/value" swap 1 addprop
  dosearch
;
 
: advanced
  1 tmp !
  " " .tell
  " Entered advanced mode." .tell
  " This wizzard will collect enough data for a search" .tell
  " by asking a few questions. To abort at any time, type @Q" .tell
  " NOTE: No *'s will be appended or prefixed as in quicksearch!" .tell
  "       All wildcards must be added manually!" .tell
  
  " " .tell
  " Do you want to use the AND or the OR search method? (A/o)" .tell
  read strip
  dup "o" stringpfx 1 = IF 0 andsearch ! ELSE 1 andsearch ! THEN
  
  " Shall the program break on every 25 lines to avoid spam? (Y/n)" .tell
  read strip
  dup "n" stringpfx 1 = IF 0 shieldon ! ELSE 1 shieldon ! THEN
  
  BEGIN
  " " .tell
  " Please enter a species pattern, or '.' for none." .tell
  read strip
  dup not IF pop "Invalid pattern." .tell CONTINUE THEN
  dup "." stringpfx 1 = not IF
   prog "criteria" tmp @ intostr 1 addprop
   prog "criteria/" tmp @ intostr strcat "/name" strcat SPECIESPROP 1 addprop
   prog swap "criteria/" tmp @ intostr strcat "/value" strcat
   swap 1 addprop
   tmp @ 1 + tmp !
  THEN
  BREAK
  REPEAT
  
  BEGIN
  " " .tell
  " Please enter a gender pattern, or '.' for none." .tell
  read strip
  dup not IF pop "Invalid pattern." .tell CONTINUE THEN
  dup "." stringpfx 1 = not IF
   prog "criteria" tmp @ intostr 1 addprop
   prog "criteria/" tmp @ intostr strcat "/name" strcat SEXPROP 1 addprop
   prog swap "criteria/" tmp @ intostr strcat "/value" strcat
   swap 1 addprop
   tmp @ 1 + tmp !
  THEN
  BREAK
  REPEAT
  
  1
  BEGIN
   " " .tell
   WHILE
   " Do you want to search for any other properties? (y/N)" .tell
   read strip
   dup "y" stringpfx 1 = not IF pop 0 CONTINUE THEN
   " Enter name of property (ex: '_scent'):" .tell
   read strip
   dup not over 
   "." stringpfx 1 = OR over "/." instring OR IF 
    pop "Invalid property name." .tell 1 CONTINUE 
   THEN
   dup "@" stringpfx 1 = over "/@" instring OR IF 
    pop "Invalid property name." .tell 1 CONTINUE
   THEN
   " Enter pattern to check against or '.' to go back." .tell
   read strip
   dup not over "." stringpfx 1 = OR IF pop pop 1 CONTINUE THEN
   prog "criteria" tmp @ intostr 1 addprop
   prog swap "criteria/" tmp @ intostr strcat "/value" strcat swap 1 addprop
   prog swap "criteria/" tmp @ intostr strcat "/name" strcat swap 1 addprop
   tmp @ 1 + tmp !
  REPEAT
  tmp @ 1 = IF
   "You didn't enter one lousy criteria!" .tell
   "How is this search supposed to work?! Please try again." .tell
   1 EXIT
  THEN
  " ListSpecies has collected enough data to fulfill your search." .tell
  " " .tell
  0
;
 
: showhelp
  "ListSpecies " VERSION strcat "  by Gyroplast" strcat
  dup .tell underline
  " " .tell
  " HELP:" .tell
  "  #help      - Nukes your favourite fast food temple." .tell
  "  <pattern>  - Does a quicksearch for a species <pattern>." .tell
  "               <pattern> uses smatch wildcars, *`s are" .tell
  "               prefixed and attached by default." .tell
  "  #advanced  - Enters the propsearch wizzard to search" .tell
  "               for user-defined properties." .tell
  "               Intended for advanced users." .tell
  " " .tell
  " Commands may be abbreviated with their first letter." .tell
  " The search pattern is case insensitive." .tell
  " " .tell
;
 
: main
  prog "criteria" remove_prop
  1 andsearch !
  0 scanwholedb !
  1 shieldon !
  dup not IF pop showhelp EXIT THEN
  strip
  dup "#a" stringpfx 1 = IF pop advanced not IF dosearch THEN EXIT THEN
  dup "#" stringpfx 1 = IF pop showhelp EXIT THEN
  "*" strcat "*" swap strcat
  doquicksearch
;

