( 
  setstatus.muf     by Gyroplast 04/29/2000   v1.0
  
  A simple but effective program to easily set your ~status or
  a similar property, which can then be displayed/evaluated by
  other programs.
  
  SETUP:
  ------
     1. Change the $defs below to customize the program
        Default is ~status, as used by whospecies.muf
     2. Set/Unset W flag on program, depending on the property you chose
     3. Create a [global] @action and link it to this program
 
  That's it.
 
  *** check http://www.gyroplast.com for this and many other programs! ***
  *** This program is distributed under the GPL. Porting and mods      ***
  *** are explicitly allowed as long as this header stays intact, and  ***
  *** the result of any modification is distributed under the GPL.     ***
  *** For a detailed description of the DOs and DONTs, read the GPL at ***
  *** http://www.gyroplast.com/help/gpl.txt   --Thank you--            ***
 
)
( *** CHANGE THIS DEFINE TO THE PROP YOU WANT TO CHANGE *** )
$def status-prop "~status"
 
( *** MAXIMUM LENGTH OF PROP *** )
$def maxlength 8
 
( *** SET '|' DELIMITED LIST OF FORBIDDEN SETTING HERE *** )
( *** A '|' MUST BE PREPENDED/APPENDED TO THE LIST! *** )
$def deny-list "|SLEEPING|"
 
( ------------ No editing below this line should be necessary ---------------)
: set-field ( [ s --  ] - Set status field to s )
  deny-list "*\|" 3 pick strcat "\|*" strcat smatch if
    "Status field cannot have that value, sorry." .tell exit
  then
  dup strlen maxlength > if
    ">>> Warning: String is longer than " maxlength intostr strcat
    " characters and will be truncated!" strcat .tell
  then
  me @ swap status-prop swap 0 addprop
  "Field set." .tell
;
: clear-field
  me @ status-prop remove_prop
  "Field cleared." .tell
;
: showhelp
  " " .tell
  "SETSTATUS v1.0     by Gyroplast@FuzzyLogic" .tell
  "------------------------------------------" .tell
  " " .tell
  "  Usage:" .tell
  "    " trig name dup ";" instr 1 - strcut pop strcat " <value> :" strcat
  "  Sets your field to <value>" strcat .tell
  "    " trig name dup ";" instr 1 - strcut pop strcat " #clear  :" strcat
  "  Clears your field" strcat .tell
  "    " trig name dup ";" instr 1 - strcut pop strcat " #help   :" strcat
  "  Summons a fire elemental" strcat .tell
  " " .tell
;
: main
  dup not if pop showhelp exit then
  dup "#h" stringpfx 1 = if pop showhelp exit then
  dup "#c" stringpfx 1 = if pop clear-field exit then
  set-field
;

