( fake.muf -- fake object routines for cmd-look -- by Jaffa Tamarin )
 
$def version prog "_version" getpropstr
 
$include $lib/look-install
$include $lib/look-messages
$include $lib/multiname
$ifdef path-support
$include $lib/path
$endif
 
( $def cmd-look #XXXXX (dbref of cmd-look)
 
( $def secure-contents-loop 1 )
( uncomment this line if you want strict security checking on the
  contents_loop subroutine.  Alternatively if the program is wiz-owned
  unauthorised use can be prevented by setting the S and H bits.
  If neither of these measures are taken any M-bitted player will
  be able to use this routine to get an inventory listing of any
  other player or location )
 
( compatibility defines for fake objects )
( settings here MUST be the same as in cmd-look )
( $def fake-show-default-is-no 1 )
( $def fake-dark-objs-are-visible 1 )
 
$def fake-dark-default $ifdef fake-show-default-is-no 1 $else 0 $endif
 
$def inside? over location over dbcmp rot rot dbcmp or
$def streq stringcmp not
$def wizlook? cmd-wizlook @ if me @ "_prefs/wizlook/" rot strcat getpropstr dup if "n*" smatch then then not
 
$ifdef masquerade
lvar masquerade-var
$def masquerade-room? "_prefs/look/masquerade" envpropstr swap pop
$define masquerade-check
   masquerade-room? dup if
    .atodbref
    dup program? over "L" flag? and not if pop "" then
   then
   masquerade-var !
$enddef
$def name masquerade-var @ dup if call else pop \name then
$endif
 
( defines for _details and fake objects )
var fake_dbref
var fake_name
var fake_dark?
$def details? #-5 dbcmp
$def fake? dup #-4 dbcmp swap details? or
$def fake_prop fake_dbref @ "_fake/" fake_name @ strcat "/" strcat rot strcat
$define fake_is_dark?
   "show" fake_prop command @ 1 parseprop
   dup if "n*" smatch else pop fake-dark-default then
$enddef
$def my_fake? me @ fake_dbref @ controls
 
( defines for contents_match )
$def cm_exact 2
$def cm_partial 1
$def cm_none 0
 
( silent modes)
$def s-noisy  0
$def s-fake   1
$def s-silent 2
 
var sticky?
var cmd-wizlook
lvar dark_location
 
: real_visible? ( d -- d b )
   me @ over dbcmp if 0 exit then ( don't see self )
   dup room? if "show_rooms" wizlook? exit then ( rooms not visible )
   dup program? if
    ( programs visible only if linkable )
    me @ over controls over "L" flag? or exit
   then
   1 over "D" flag? if
    pop sticky? @ s-fake > if 0 else me @ over controls then
   then
   dark_location @ if
    over owner me @ owner dbcmp "ignore_dark" wizlook? or and
   then
;
 
$ifdef fake-dark-objs-are-visible
$def fake_visible? 1
$else
: fake_visible? ( -- b )
   1 fake_is_dark? dup fake_dark? ! if
    pop sticky? @ if 0 else my_fake? then
   then
;
$endif
 
lvar subroutine
lvar prop_name
$ifdef secure-contents-loop
: contents_loop_safe ( d x -- )
$else
: contents_loop ( d x -- )
$endif
   subroutine ! dup fake_dbref !
   dup "D" flag? dup if pop
    sticky? @ s-fake > if 1 else me @ over controls not then
   then dark_location !
   $ifdef masquerade dup masquerade-check $endif
   contents begin
    dup #-1 dbcmp not
   while
    real_visible? if dup name subroutine @ execute then
    next
   repeat pop
   fake_dbref @ "/_fake/"
   begin nextprop dup while
    dup prop_name ! 7 strcut swap pop dup fake_name !
    fake_visible? if #-4 swap subroutine @ execute then pop
    fake_dbref @ prop_name @
   repeat pop
;
 
$ifdef secure-contents-loop
: contents_loop
   caller cmd-look dbcmp not if "Permission denied." abort then
   contents_loop_safe
;
$else
$def contents_loop_safe contents_loop
$endif
 
lvar fake_dbref_t
lvar fake_name_t
: contents_match_sub ( s <obj> b <obj> name[;name] -- s <obj> b <obj> )
   dup 6 pick instring if
    dup 6 pick multi-streq if pop
     ( exact match )
     over cm_exact < random 2 % or if
      rot pop swap pop cm_exact over
      fake_dbref @ fake_dbref_t !
      fake_name @ fake_name_t !
     then
    else
     " " swap strcat " " 6 pick strcat instring if
      ( partial match )
      over cm_partial > if exit then ( already got better match )
      over cm_partial = if rot pop #-2 rot rot exit then ( ambiguous )
      rot pop swap pop cm_partial over
      fake_dbref @ fake_dbref_t !
      fake_name @ fake_name_t !
     then
    then
   else
    pop
   then
;
 
: contents_match ( s d <obj> b -- s <obj> b )
   rot dup fake? if pop exit then
   caller cmd-look dbcmp not if
    me @ "S" flag?
    me @ "_prefs/look/silent" envpropstr swap pop dup if "y*" smatch then or
$ifndef no-K-support
    loc @ "K" flag? or
$endif
    if s-silent else
     me @ "_prefs/look/silent" getpropstr dup if
      dup "q*" smatch if pop s-silent else "f*" smatch
       ( dup if s-fake else s-noisy then )
      then
     else pop s-noisy then
    then
    sticky? !
    0 cmd-wizlook !
   then
   'contents_match_sub contents_loop_safe
   caller cmd-look dbcmp if
    dup cm_exact = not if
     3 pick dup "@*" smatch swap "/" instr or not if
      ( check for an exact _details match )
      fake_dbref @ "_details/" 5 pick strcat
      over room? if multi-envpropstr swap fake_dbref ! else multi-getpropstr then
      if dup "/" rinstr strcut fake_name ! pop pop pop #-5 cm_exact exit then
     then
    then
   then
   fake_dbref_t @ fake_dbref !
   fake_name_t @ fake_name !
;
 
$def atodbref .atodbref dup ok? not if pop #-1 then
 
lvar match_by_ref
lvar match_exact
: matchit ( s -- s d )
   dup "{$*|#[0-9]*|\\**}*" smatch dup match_by_ref ! match_exact !
   dup dup "#[0-9]*" smatch if atodbref else match then
   dup ok? not if exit then
   match_by_ref @ if
    dup loc @ inside? over me @ inside? or not if
     ( farlook only on objects controlled by player )
     me @ over controls not if pop #-1 exit then
    then
   else
    dup exit? if
     ( don't match dark actions unless they have a desc )
     dup "D" flag? if dup getlink room? not if
      dup "_/de" getpropstr not if pop #-1 exit then
     then then
     ( don't match exit against leading substring )
     ";" over \name ";" strcat strcat
     ";" 4 pick ";" strcat strcat
     instring not if pop #-1 exit then
     1 match_exact !
    else
$ifdef masquerade
     loc @ masquerade-room? if pop #-1 exit then
$endif
     over over \name streq match_exact !
    then
   then
;
 
: match_trigger ( s -- 1 or "error" 0 )
   dup "here" streq if pop loc @ trigger ! 1 exit then
   dup "me" streq if pop me @ trigger ! 1 exit then
   dup "home" streq if pop me @ getlink trigger ! 1 exit then
   matchit
   dup player? over thing? or if
    match_exact @ if trigger ! pop 1 exit then
    over over \name over strlen strcut pop streq if trigger ! pop 1 exit then
   then
   swap match_by_ref @ if #-1 0 else
    loc @ #-1 0 contents_match
    dup cm_exact = if pop trigger ! pop pop 1 exit then
    me @ rot rot contents_match
    dup cm_exact = if pop trigger ! pop pop 1 exit then
   then
   ( d s <obj> b -- )
$ifdef path-support
   caller cmd-look dbcmp if match_exact @ not if
    loc @ 4 pick pathmatch dup if
     fake_name ! loc @ fake_dbref ! #-6 trigger !
     pop pop pop pop 1 exit
    else pop then
   then then
$endif
   not match_exact @ or if pop pop else swap pop swap pop then
   ( <obj> )
   dup #-1 dbcmp if pop not-here 0 exit then
   dup #-2 dbcmp if pop ambiguous 0 exit then
   trigger ! 1
;
 
: main
   "Jaffa's fake.muf routines v" version strcat
   caller cmd-look dbcmp if version swap else .tell then
;
 
PUBLIC match_trigger
PUBLIC contents_match
PUBLIC contents_loop

