( Colorization support for Jaffa's cmd-look )
 
( To use cmd-look's color selections in your own programs, e.g. for a
( contents program wanting to reproduce the colors selected by the
( player for cmd-look's contents listing, $include this library in
( your program, and use the functions:
(
(     color-init              -- MUST be called before any other
(                                functions in this library are used
(
(     <text> <type> add-color -- add color appropriate to <type>
(                                (types listed in look #help color)
(     <db> color-name         -- get name, with appropriate color
(
(     <db> color-unparseobj   -- get colored name and flags
(
(     <db> <name> item-color  -- alternative to color-name, where
(                                <name> is not necessarily the name
(                                of the item.  Leaves <db> and
(                                colorized <name> on the stack
(                                For fake objects, the third var
(                                should be TRUE for a hidden fake
(
( Notes: color-name requires you also $include $lib/fake
(        these routines use var slots 40 through 50 )
 
$include $lib/multiname
$ifndef __glowver
$include $lib/ansi
$endif
 
$def r0 $ifdef jaffa-install-loc jaffa-install-loc $else #0 $endif
$def FB-perms $ifdef __glowver "compatible_muf" sysparm dup if "y*" smatch then $else 1 $endif
$def write-r0? r0 #0 dbcmp $ifdef prog __glowver mlevel 3 > FB-perms or and $endif
 
$def fake? int -3 <
$def streq stringcmp not
 
var fake-dbref
var fake-name
var fake-dark?
 
$def no-color 40 variable
$def c-hidden 41 variable
$def c-fake 42 variable
$def c-player 43 variable
$def c-zombie 44 variable
$def c-program 45 variable
$def c-room 46 variable
$def c-vehicle 47 variable
$def c-item 48 variable
$def c-refs 49 variable
$def no-unparseobj 50 variable
 
: get-color
   "_prefs/look/colors/" swap strcat
   me @ over envpropstr swap pop
   dup not if pop prog over getpropstr then
   dup not if pop
    caller over getpropstr
    dup if prog 3 pick 3 pick setprop then
   then
   swap pop
   dup not if exit then
   prog "_colors/" rot strcat getpropstr
;
 
: get-color-public
   dup "{hidden|fake|player|zombie|program|room|vehicle|item|refs}" smatch if
    dup "refs" streq if pop c-refs @ exit then
    dup "room" streq if pop c-room @ exit then
    dup "hidden" streq if pop c-hidden @ exit then
    dup "fake" streq if pop c-fake @ exit then
    dup "player" streq if pop c-player @ exit then
    dup "zombie" streq if pop c-zombie @ exit then
    dup "program" streq if pop c-program @ exit then
    dup "vehicle" streq if pop c-vehicle @ exit then
    dup "item" streq if pop c-item @ exit then
    "Unexpected error in $lib/look-color." abort
   else
    get-color
   then
;
 
: color-init
$ifdef Glow-unparseobj
   me @ "_prefs/look/unparseobj" getpropstr
   dup if "n*" smatch then no-unparseobj !
$endif
   me @ $ifdef __glowver "C" flag? $else ansi? $endif
   not dup no-color ! if exit then
   me @ "_prefs/look/colors" getpropstr
   dup if "n*" smatch if 1 no-color ! exit then else pop then
   "item" get-color c-item !
   "fake" get-color dup not if pop c-item @ then c-fake !
   "hidden" get-color dup not if pop c-fake @ then c-hidden !
   "player" get-color dup not if pop c-item @ then c-player !
   "zombie" get-color dup not if pop c-player @ then c-zombie !
   "program" get-color dup not if pop c-item @ then c-program !
   "room" get-color dup not if pop c-item @ then c-room !
   "vehicle" get-color dup not if pop c-item @ then c-vehicle !
   "refs" get-color c-refs !
;
 
: item-color ( <obj> name -- <obj> name )
   over fake? if
    fake-dark? @ if
     c-hidden
    else
     c-fake
    then
   else
    over .person? if
     over player? if
      c-player
     else
      c-zombie
     then
    else
     over program? if
      c-program
     else
      over room? if
       c-room
      else
       over "V" flag? if
        c-vehicle
       else
        c-item
       then
      then
     then
    then
   then
   @ swap strcat
;
 
: color-unparseobj ( <obj> -- name )
$ifdef Glow-unparseobj
   no-unparseobj @ if
$endif
    no-color @ if unparseobj exit then
    dup dup unparseobj swap name strlen strcut c-refs @ swap strcat strcat
$ifdef Glow-unparseobj
   else
    dup Glow-unparseobj call no-color @ if swap pop exit then
   then
$endif
   item-color swap pop
;
 
: fake-unparseobj ( <obj> -- name )
   fake-name @ multi-1name
   no-color @ if " [Fake]" strcat swap pop exit then
   over "$lib/fake" match "fdark?" call fake-dark? !
   c-refs @ " [Fake]" strcat strcat
   item-color swap pop
;
 
: set-unparseobj
   "#" swap intostr strcat
   prog "_defs/Glow-unparseobj" 3 pick setprop
   write-r0? if #0 else me @ then
   "_defs/Glow-unparseobj" rot setprop
;
 
: main
   prog "_defs/var3" fake-dark? int intostr setprop
   prog "_defs/look-color" "#" prog intostr strcat setprop
   "$defs/color-unparseobj" match dup program? if
    "Color unparseobj program found: " over dup call strcat
    me @ swap ansi_notify
    set-unparseobj exit
   else pop then
$ifdef __glowver
   "Searching for Glow-unparseobj..." .tell
   0 begin dup dbtop int < while
    dup dbref dup ok? if dup program? if
     dup name "." .split pop "Glow-unparseobj" streq if
      "Found " swap dup call strcat me @ swap ansi_notify
      set-unparseobj exit
     then
    then then
    pop 1 +
   repeat
   pop "Not found.  Built-in color mapping will be used." .tell
$endif
;
 
PUBLIC get-color-public
PUBLIC item-color
PUBLIC color-unparseobj
PUBLIC fake-unparseobj
PUBLIC color-init

