(header 3 lines -- Player-Info.muf, programmed by Jordan Greywolf -- 22 Jul 94
pinfo #help for help -- This program has already been installed as a global.
)
lvar existsflag
lvar proploc
: tell
  me @ swap notify
;
: tell-call
  dup 1 strcut pop "@" strcmp not if ( check for "@", signifying call )
    1 strcut swap pop ( dispose of "@" )
    striplead striptail dup " " instr dup not if ( check for space divider )
      pop "" ( if not, parameter is empty )
    else
      1 - strcut striplead striptail ( otherwise, split )
    then
    swap dup 1 strcut pop "$" strcmp not if ( check for "$", register )
      match
    else
      atoi dbref dup program? not if
        pop tell ( if not program, just display parameter )
      else
        call ( otherwise, call, passing parameter )
      then
    then
  else
    ( otherwise, if there's no program call, display as normal )
    tell
  then
;
: info-help
 "PLAYER-INFO, programmed by Jordan Greywolf" tell
 "-----" tell
 "This utility is for players who wish to make information about themselves" 
 tell
 "and/or their characters available for whomever cares to look.  It is" tell
 "entirely voluntary -- There is no obligation to even bother providing" tell
 "any of this information, but it could be helpful for email correspondence,"
 tell
 "finding people with similar interests, or providing information on your" tell
 "character for roleplaying purposes." tell
 "To see the list of fields, type:" tell
 ".    pinfo #fields" tell
 "-" tell
 "To access information on a player, use the command in the format of:" tell
 "   pinfo {field} {player}" tell
 "or," tell
 "   pinfo {player}" tell
 "which will list all the fields." tell
 "-" tell
 "To set information on yourself, use the format of:" tell
 "   pinfo #{field}={text}" tell
;
: info-fields
 "Player-Info Fields Currently Supported:" tell
 "* (c)haracter -- quick summary of your character's history, genre, world," 
 tell
 ".            skills, interests, IC/OOC, etc." tell
 "* (p)rofile   -- major interests, hobbies, etc.  Whether you use it for RL" 
 tell
 ".            or VL info (or both) is up to you, of course." tell
 "* (e)mail     -- email address" tell
 "* (a)ddress   -- mailing address" tell
 "* (r)esidence -- your 'residence' on the MUCK: apartment complex, etc." tell
 "* (m)isc      -- general info about you" tell
 "* (b)irthday  -- =)" tell
 "* (t)inyplot  -- what are your preferences regarding TinyPlots?" tell
 ".            (for further info on this, type 'pinfo #tinyplots')" tell
 "-" tell
;
: info-tinyplot
 "Player-Info 'TinyPlot' Entries" tell
 "For the 'tinyplots' field, there are various ways of specifying just what"
 tell
 "you're looking for in roleplaying.  The following are suggestions on ways"
 tell
 "you might do that, though you're of course free to utilize this field"
 tell
 "however you see fit." tell
 "*       yes = I'd love to participate in a TinyPlot!" tell
 "*        no = Please leave me out of TinyPlots." tell
 "*  !violent = No violence, please." tell
 "* !religion = No religious (or anti-religious) themes, please." tell
 "*    !angst = No angst (heavy melodrama), please." tell
 "*    !magic = No exceedingly complex magical mumbo-jumbo, please." tell
 "* !hightech = No exceedingly complex high-tech mumbo-jumbo, please." tell
 "*     !toon = No toonish stuff, please.  Please don't drop anvils on me." 
 tell
 "*         G = G-rated {...or other 'movie ratings' might be used}" tell
 "* highpower = High-Powered -- Bring on the action!" tell
 "*   puzzles = Problem Solver.  Preference for mysteries/puzzles." tell
 "*        =) = Silly, light-hearted roleplaying preferred." tell
;
: info-get ( s1 s2 -- : uses proploc variable for dbref input )
  ( s1 = category; s2 = propname )
 proploc @ over getpropstr not if
  pop pop
 else
  1 existsflag !
  swap tell ( display category header )
  proploc @ swap "Player-Info.muf" 1 parseprop
  tell-call
 then
;
: pmatch-rtn
 .pmatch me @ pennies #0 "_sys/maxpennies" getpropstr atoi < if
  me @ 1 addpennies
 then
;
: store-proploc-rtn
  ( check to see if target player has proploc.)
  ( If so, store proploc in the "proploc" variable.)
  ( Otherwise, store the player's dbref there.)
  dup "_proploc" getpropstr dup not if
    pop dup proploc !  ( store player dbref in variable )
  else
    atoi dbref dup owner 
    3 pick dbcmp not if  ( make sure proploc is owned by player )
      pop dup proploc ! ( store player dbref in variable if not )
    else
      proploc ! ( store proploc in variable )
    then
  then
;
: main
 0 existsflag !
 dup 1 strcut swap "#" strcmp not if
  me @ "_proploc" getpropstr dup not if
   pop me @
  else
   atoi dbref dup owner me @ dbcmp not if
    pop me @
   then
  then proploc !
  1 strcut swap
  dup "h" stringcmp not if       ( go to "help" if selected )
   info-help pop exit
  then
  dup "f" stringcmp not if       ( go to "fields" if selected )
   info-fields pop exit
  then
  dup "t" stringcmp not 3 pick "=" instr not and if
   info-tinyplot pop exit        ( "pinfo #t" without the "=" calls tp info )
  then
  dup "" stringcmp not if        ( error if user just typed "pinfo #" )
   "You must specify a command.  Type 'pinfo #help' for help." tell exit
  then
  "eampbcrt" over instring if    ( see if a valid command is specified )
   swap dup "=" instr dup not if
    "{no setting specified -- no '=' was found}" tell
    exit
   then
   strcut swap pop
   "_ui/" rot strcat
   proploc @ swap rot dup not if   ( "pinfo #{field}=" clears the field )
    "{field cleared}" tell pop over over remove_prop "_" "/" subst
    remove_prop
   else                            ( "pinfo #{field}={setting}" sets field )
    "{field set to '" over "'}" strcat strcat tell .stripspaces 0 addprop
   then
  else
   pop "That command is not recognized." tell
  then
  pop exit
 else
  pop
 then
 dup " " instr dup not if
  pop dup "me" stringcmp not if
   pop me @
  else
   pmatch-rtn
  then
  dup #-1 dbcmp if
   "No player by that name can be found." tell
   "Use in format of 'pinfo {field} {player}' or 'pinfo {player}'." tell
   exit
  then
  dup #-2 dbcmp if
   "It is not clear which player you mean." tell
   "Use in format of 'pinfo {field} {player}' or 'pinfo {player}'." tell
   exit
  then
  store-proploc-rtn
  dup trigger ! name " Player Information" strcat tell
  "." tell
  "Character: "
  "_ui/c" info-get
  "Profile: "
  "_ui/p" info-get
  "Email: "
  "_ui/e" info-get
  "Address: "
  "_ui/a" info-get
  "Residence: "
  "_ui/r" info-get
  "Miscellaneous: "
  "_ui/m" info-get
  "Birthday: "
  "_ui/b" info-get
  "TinyPlot Prefs: "
  "_ui/t" info-get
  existsflag @ not if
   "{no entry}" tell exit
  then
  "{done}" tell
  exit
 then
 strcut
 dup "me" stringcmp not if
  pop me @
 else
  pmatch-rtn
 then
 dup #-1 dbcmp if
  "No player by that name can be found." tell
  exit
 then
 dup #-2 dbcmp if
  "It is not clear which player you mean." tell
  exit
 then
 store-proploc-rtn
 trigger !
 1 strcut pop "_ui/" swap
 dup "m" stringcmp not if
  "Miscellaneous"
 else
  dup "p" stringcmp not if
   "Profile"
  else
   dup "a" stringcmp not if
    "Address"
   else
    dup "e" stringcmp not if
     "Email"
    else
     dup "b" stringcmp not if
      "Birthday"
     else
      dup "c" stringcmp not if
       "Character"
      else
       dup "r" stringcmp not if
        "Residence"
       else
        dup "t" stringcmp not if
         "TinyPlot Prefs"
        else
         dup
        then
       then
      then
     then
    then
   then
  then
 then
 " / " strcat
 trigger @ name ": " strcat strcat rot rot strcat
 info-get existsflag @ not if "{no entry}" tell exit then
;

